extern "C" {
    #[no_mangle]
    pub fn snd_device_name_free_hint(hints: *mut *mut libc::c_void) -> libc::c_int;

    #[no_mangle]
    pub fn snd_device_name_get_hint(
        hint: *const libc::c_void,
        id: *const libc::c_char,
    ) -> *mut libc::c_char;

    #[no_mangle]
    pub fn snd_device_name_hint(
        card: libc::c_int,
        iface: *const libc::c_char,
        hints: *mut *mut *mut libc::c_void,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn dlopen(__file: *const libc::c_char, __mode: libc::c_int) -> *mut libc::c_void;

    #[no_mangle]
    pub fn dlsym(__handle: *mut libc::c_void, __name: *const libc::c_char) -> *mut libc::c_void;

    #[no_mangle]
    pub fn dlerror() -> *mut libc::c_char;
    #[no_mangle]
    pub fn __errno_location() -> *mut libc::c_int;
    #[no_mangle]
    pub fn snd_lib_error_set_handler(
        handler: crate::stdlib::snd_lib_error_handler_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_strerror(errnum: libc::c_int) -> *const libc::c_char;
    #[no_mangle]
    pub fn eventfd_read(__fd: libc::c_int, __value: *mut crate::stdlib::eventfd_t) -> libc::c_int;

    #[no_mangle]
    pub fn eventfd(__count: libc::c_uint, __flags: libc::c_int) -> libc::c_int;

    #[no_mangle]
    pub fn eventfd_write(__fd: libc::c_int, __value: crate::stdlib::eventfd_t) -> libc::c_int;
    #[no_mangle]
    pub fn open(__file: *const libc::c_char, __oflag: libc::c_int, _: ...) -> libc::c_int;

    #[no_mangle]
    pub fn fcntl(__fd: libc::c_int, __cmd: libc::c_int, _: ...) -> libc::c_int;
    #[no_mangle]
    pub fn ntohs(__netshort: crate::stdlib::uint16_t) -> crate::stdlib::uint16_t;

    #[no_mangle]
    pub fn htonl(__hostlong: crate::stdlib::uint32_t) -> crate::stdlib::uint32_t;

    #[no_mangle]
    pub fn htons(__hostshort: crate::stdlib::uint16_t) -> crate::stdlib::uint16_t;
    #[no_mangle]
    pub fn strftime(
        __s: *mut libc::c_char,
        __maxsize: crate::stddef_h::size_t,
        __format: *const libc::c_char,
        __tp: *const crate::stdlib::tm,
    ) -> crate::stddef_h::size_t;

    #[no_mangle]
    pub fn localtime(__timer: *const crate::stdlib::time_t) -> *mut crate::stdlib::tm;

    #[no_mangle]
    pub fn clock_gettime(
        __clock_id: crate::stdlib::clockid_t,
        __tp: *mut crate::stdlib::timespec,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn inet_ntoa(__in: crate::stdlib::in_addr) -> *mut libc::c_char;
    #[no_mangle]
    pub fn ioctl(__fd: libc::c_int, __request: libc::c_ulong, _: ...) -> libc::c_int;
    #[no_mangle]
    pub fn mallopt(__param: libc::c_int, __val: libc::c_int) -> libc::c_int;
    #[no_mangle]
    pub fn log10(_: libc::c_double) -> libc::c_double;

    #[no_mangle]
    pub fn floor(_: libc::c_double) -> libc::c_double;
    pub type _snd_mixer;

    pub type _snd_mixer_class;

    pub type _snd_mixer_elem;

    pub type _snd_mixer_selem_id;

    #[no_mangle]
    pub fn snd_mixer_selem_id_set_index(
        obj: *mut crate::stdlib::snd_mixer_selem_id_t,
        val: libc::c_uint,
    );

    #[no_mangle]
    pub fn snd_mixer_selem_id_set_name(
        obj: *mut crate::stdlib::snd_mixer_selem_id_t,
        val: *const libc::c_char,
    );

    #[no_mangle]
    pub fn snd_mixer_find_selem(
        mixer: *mut crate::stdlib::snd_mixer_t,
        id: *const crate::stdlib::snd_mixer_selem_id_t,
    ) -> *mut crate::stdlib::snd_mixer_elem_t;

    #[no_mangle]
    pub fn snd_mixer_selem_has_playback_switch(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_set_playback_switch_all(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
        value: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_get_playback_dB_range(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
        min: *mut libc::c_long,
        max: *mut libc::c_long,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_get_playback_volume_range(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
        min: *mut libc::c_long,
        max: *mut libc::c_long,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_set_playback_volume(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
        channel: crate::stdlib::snd_mixer_selem_channel_id_t,
        value: libc::c_long,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_set_playback_dB(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
        channel: crate::stdlib::snd_mixer_selem_channel_id_t,
        value: libc::c_long,
        dir: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_get_playback_volume(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
        channel: crate::stdlib::snd_mixer_selem_channel_id_t,
        value: *mut libc::c_long,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_id_sizeof() -> crate::stddef_h::size_t;

    #[no_mangle]
    pub fn snd_mixer_open(
        mixer: *mut *mut crate::stdlib::snd_mixer_t,
        mode: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_attach(
        mixer: *mut crate::stdlib::snd_mixer_t,
        name: *const libc::c_char,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_register(
        mixer: *mut crate::stdlib::snd_mixer_t,
        options: *mut crate::stdlib::snd_mixer_selem_regopt,
        classp: *mut *mut crate::stdlib::snd_mixer_class_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_load(mixer: *mut crate::stdlib::snd_mixer_t) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_first_elem(
        mixer: *mut crate::stdlib::snd_mixer_t,
    ) -> *mut crate::stdlib::snd_mixer_elem_t;

    #[no_mangle]
    pub fn snd_mixer_elem_next(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
    ) -> *mut crate::stdlib::snd_mixer_elem_t;

    #[no_mangle]
    pub fn snd_mixer_selem_has_playback_volume(
        elem: *mut crate::stdlib::snd_mixer_elem_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_mixer_selem_get_id(
        element: *mut crate::stdlib::snd_mixer_elem_t,
        id: *mut crate::stdlib::snd_mixer_selem_id_t,
    );

    #[no_mangle]
    pub fn snd_mixer_selem_id_get_name(
        obj: *const crate::stdlib::snd_mixer_selem_id_t,
    ) -> *const libc::c_char;

    #[no_mangle]
    pub fn snd_mixer_selem_id_get_index(
        obj: *const crate::stdlib::snd_mixer_selem_id_t,
    ) -> libc::c_uint;

    #[no_mangle]
    pub fn snd_mixer_close(mixer: *mut crate::stdlib::snd_mixer_t) -> libc::c_int;
    #[no_mangle]
    pub fn mlockall(__flags: libc::c_int) -> libc::c_int;
    pub type mpg123_handle_struct;
    #[no_mangle]
    pub fn getaddrinfo(
        __name: *const libc::c_char,
        __service: *const libc::c_char,
        __req: *const crate::stdlib::addrinfo,
        __pai: *mut *mut crate::stdlib::addrinfo,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn freeaddrinfo(__ai: *mut crate::stdlib::addrinfo);
    pub type _snd_output;

    #[no_mangle]
    pub fn snd_output_stdio_attach(
        outputp: *mut *mut crate::stdlib::snd_output_t,
        fp: *mut crate::stdlib::FILE,
        _close: libc::c_int,
    ) -> libc::c_int;
    pub type _snd_pcm;

    pub type _snd_pcm_hw_params;

    #[no_mangle]
    pub fn snd_pcm_open(
        pcm: *mut *mut crate::stdlib::snd_pcm_t,
        name: *const libc::c_char,
        stream: crate::stdlib::snd_pcm_stream_t,
        mode: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_close(pcm: *mut crate::stdlib::snd_pcm_t) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_start(pcm: *mut crate::stdlib::snd_pcm_t) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_state(pcm: *mut crate::stdlib::snd_pcm_t) -> crate::stdlib::snd_pcm_state_t;

    #[no_mangle]
    pub fn snd_pcm_delay(
        pcm: *mut crate::stdlib::snd_pcm_t,
        delayp: *mut crate::stdlib::snd_pcm_sframes_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_avail_update(
        pcm: *mut crate::stdlib::snd_pcm_t,
    ) -> crate::stdlib::snd_pcm_sframes_t;

    #[no_mangle]
    pub fn snd_pcm_writei(
        pcm: *mut crate::stdlib::snd_pcm_t,
        buffer: *const libc::c_void,
        size: crate::stdlib::snd_pcm_uframes_t,
    ) -> crate::stdlib::snd_pcm_sframes_t;

    #[no_mangle]
    pub fn snd_pcm_wait(pcm: *mut crate::stdlib::snd_pcm_t, timeout: libc::c_int) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_recover(
        pcm: *mut crate::stdlib::snd_pcm_t,
        err: libc::c_int,
        silent: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_any(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_sizeof() -> crate::stddef_h::size_t;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_access(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        _access: crate::stdlib::snd_pcm_access_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_format(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: crate::stdlib::snd_pcm_format_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_channels(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: libc::c_uint,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_test_rate(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: libc::c_uint,
        dir: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_rate(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: libc::c_uint,
        dir: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_rate_resample(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: libc::c_uint,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_get_period_size(
        params: *const crate::stdlib::snd_pcm_hw_params_t,
        frames: *mut crate::stdlib::snd_pcm_uframes_t,
        dir: *mut libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_period_size_near(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: *mut crate::stdlib::snd_pcm_uframes_t,
        dir: *mut libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_periods_near(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: *mut libc::c_uint,
        dir: *mut libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_buffer_time_near(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: *mut libc::c_uint,
        dir: *mut libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_get_buffer_size(
        params: *const crate::stdlib::snd_pcm_hw_params_t,
        val: *mut crate::stdlib::snd_pcm_uframes_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_hw_params_set_buffer_size_near(
        pcm: *mut crate::stdlib::snd_pcm_t,
        params: *mut crate::stdlib::snd_pcm_hw_params_t,
        val: *mut crate::stdlib::snd_pcm_uframes_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_format_name(format: crate::stdlib::snd_pcm_format_t) -> *const libc::c_char;

    #[no_mangle]
    pub fn snd_pcm_dump(
        pcm: *mut crate::stdlib::snd_pcm_t,
        out: *mut crate::stdlib::snd_output_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_mmap_begin(
        pcm: *mut crate::stdlib::snd_pcm_t,
        areas: *mut *const crate::stdlib::snd_pcm_channel_area_t,
        offset: *mut crate::stdlib::snd_pcm_uframes_t,
        frames: *mut crate::stdlib::snd_pcm_uframes_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn snd_pcm_mmap_commit(
        pcm: *mut crate::stdlib::snd_pcm_t,
        offset: crate::stdlib::snd_pcm_uframes_t,
        frames: crate::stdlib::snd_pcm_uframes_t,
    ) -> crate::stdlib::snd_pcm_sframes_t;
    #[no_mangle]
    pub fn poll(
        __fds: *mut crate::stdlib::pollfd,
        __nfds: crate::stdlib::nfds_t,
        __timeout: libc::c_int,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn pthread_create(
        __newthread: *mut crate::stdlib::pthread_t,
        __attr: *const crate::stdlib::pthread_attr_t,
        __start_routine: Option<unsafe extern "C" fn(_: *mut libc::c_void) -> *mut libc::c_void>,
        __arg: *mut libc::c_void,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_join(
        __th: crate::stdlib::pthread_t,
        __thread_return: *mut *mut libc::c_void,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_attr_init(__attr: *mut crate::stdlib::pthread_attr_t) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_attr_destroy(__attr: *mut crate::stdlib::pthread_attr_t) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_attr_setstacksize(
        __attr: *mut crate::stdlib::pthread_attr_t,
        __stacksize: crate::stddef_h::size_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_mutex_init(
        __mutex: *mut crate::stdlib::pthread_mutex_t,
        __mutexattr: *const crate::stdlib::pthread_mutexattr_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_mutex_destroy(__mutex: *mut crate::stdlib::pthread_mutex_t) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_mutex_lock(__mutex: *mut crate::stdlib::pthread_mutex_t) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_mutex_unlock(__mutex: *mut crate::stdlib::pthread_mutex_t) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_mutexattr_init(__attr: *mut crate::stdlib::pthread_mutexattr_t) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_mutexattr_destroy(
        __attr: *mut crate::stdlib::pthread_mutexattr_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_mutexattr_setprotocol(
        __attr: *mut crate::stdlib::pthread_mutexattr_t,
        __protocol: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn pthread_setschedparam(
        __target_thread: crate::stdlib::pthread_t,
        __policy: libc::c_int,
        __param: *const crate::stdlib::sched_param,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn select(
        __nfds: libc::c_int,
        __readfds: *mut crate::stdlib::fd_set,
        __writefds: *mut crate::stdlib::fd_set,
        __exceptfds: *mut crate::stdlib::fd_set,
        __timeout: *mut crate::stdlib::timeval,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn sscanf(_: *const libc::c_char, _: *const libc::c_char, _: ...) -> libc::c_int;

    #[no_mangle]
    pub fn sprintf(_: *mut libc::c_char, _: *const libc::c_char, _: ...) -> libc::c_int;

    #[no_mangle]
    pub static mut stdout: *mut crate::stdlib::FILE;

    #[no_mangle]
    pub fn fwrite(
        _: *const libc::c_void,
        _: libc::c_ulong,
        _: libc::c_ulong,
        _: *mut crate::stdlib::FILE,
    ) -> libc::c_ulong;

    #[no_mangle]
    pub fn fopen(_: *const libc::c_char, _: *const libc::c_char) -> *mut crate::stdlib::FILE;

    #[no_mangle]
    pub fn snprintf(
        _: *mut libc::c_char,
        _: libc::c_ulong,
        _: *const libc::c_char,
        _: ...
    ) -> libc::c_int;

    #[no_mangle]
    pub fn fclose(__stream: *mut crate::stdlib::FILE) -> libc::c_int;

    #[no_mangle]
    pub fn fgets(
        __s: *mut libc::c_char,
        __n: libc::c_int,
        __stream: *mut crate::stdlib::FILE,
    ) -> *mut libc::c_char;

    #[no_mangle]
    pub fn fputs(__s: *const libc::c_char, __stream: *mut crate::stdlib::FILE) -> libc::c_int;

    #[no_mangle]
    pub static mut stderr: *mut crate::stdlib::FILE;

    #[no_mangle]
    pub fn fflush(__stream: *mut crate::stdlib::FILE) -> libc::c_int;

    #[no_mangle]
    pub fn fprintf(_: *mut crate::stdlib::FILE, _: *const libc::c_char, _: ...) -> libc::c_int;

    #[no_mangle]
    pub fn printf(_: *const libc::c_char, _: ...) -> libc::c_int;

    #[no_mangle]
    pub fn vfprintf(
        _: *mut crate::stdlib::FILE,
        _: *const libc::c_char,
        _: ::std::ffi::VaList,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn getenv(__name: *const libc::c_char) -> *mut libc::c_char;

    #[no_mangle]
    pub fn exit(_: libc::c_int) -> !;

    #[no_mangle]
    pub fn malloc(_: libc::c_ulong) -> *mut libc::c_void;

    #[no_mangle]
    pub fn free(__ptr: *mut libc::c_void);

    #[no_mangle]
    pub fn atoi(__nptr: *const libc::c_char) -> libc::c_int;
    pub type FLAC__StreamDecoderPrivate;

    pub type FLAC__StreamDecoderProtected;
    #[no_mangle]
    pub fn memcpy(
        _: *mut libc::c_void,
        _: *const libc::c_void,
        _: libc::c_ulong,
    ) -> *mut libc::c_void;

    #[no_mangle]
    pub fn memcmp(_: *const libc::c_void, _: *const libc::c_void, _: libc::c_ulong) -> libc::c_int;

    #[no_mangle]
    pub fn strcmp(_: *const libc::c_char, _: *const libc::c_char) -> libc::c_int;

    #[no_mangle]
    pub fn memmove(
        _: *mut libc::c_void,
        _: *const libc::c_void,
        _: libc::c_ulong,
    ) -> *mut libc::c_void;

    #[no_mangle]
    pub fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong) -> *mut libc::c_void;

    #[no_mangle]
    pub fn strchr(_: *const libc::c_char, _: libc::c_int) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strstr(_: *const libc::c_char, _: *const libc::c_char) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strcat(_: *mut libc::c_char, _: *const libc::c_char) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strncpy(
        _: *mut libc::c_char,
        _: *const libc::c_char,
        _: libc::c_ulong,
    ) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strncat(
        _: *mut libc::c_char,
        _: *const libc::c_char,
        _: libc::c_ulong,
    ) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strcpy(_: *mut libc::c_char, _: *const libc::c_char) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strncmp(_: *const libc::c_char, _: *const libc::c_char, _: libc::c_ulong)
        -> libc::c_int;

    #[no_mangle]
    pub fn strdup(_: *const libc::c_char) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strrchr(_: *const libc::c_char, _: libc::c_int) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strtok(_: *mut libc::c_char, _: *const libc::c_char) -> *mut libc::c_char;

    #[no_mangle]
    pub fn strlen(_: *const libc::c_char) -> libc::c_ulong;

    #[no_mangle]
    pub fn strerror(_: libc::c_int) -> *mut libc::c_char;
    pub type _IO_wide_data;

    pub type _IO_codecvt;

    pub type _IO_marker;
    #[no_mangle]
    pub fn connect(
        __fd: libc::c_int,
        __addr: *const crate::stdlib::sockaddr,
        __len: crate::stdlib::socklen_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn getsockopt(
        __fd: libc::c_int,
        __level: libc::c_int,
        __optname: libc::c_int,
        __optval: *mut libc::c_void,
        __optlen: *mut crate::stdlib::socklen_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn socket(
        __domain: libc::c_int,
        __type: libc::c_int,
        __protocol: libc::c_int,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn getsockname(
        __fd: libc::c_int,
        __addr: *mut crate::stdlib::sockaddr,
        __len: *mut crate::stdlib::socklen_t,
    ) -> libc::c_int;

    #[no_mangle]
    pub fn send(
        __fd: libc::c_int,
        __buf: *const libc::c_void,
        __n: crate::stddef_h::size_t,
        __flags: libc::c_int,
    ) -> crate::stdlib::ssize_t;

    #[no_mangle]
    pub fn recv(
        __fd: libc::c_int,
        __buf: *mut libc::c_void,
        __n: crate::stddef_h::size_t,
        __flags: libc::c_int,
    ) -> crate::stdlib::ssize_t;

    #[no_mangle]
    pub fn sendto(
        __fd: libc::c_int,
        __buf: *const libc::c_void,
        __n: crate::stddef_h::size_t,
        __flags: libc::c_int,
        __addr: *const crate::stdlib::sockaddr,
        __addr_len: crate::stdlib::socklen_t,
    ) -> crate::stdlib::ssize_t;

    #[no_mangle]
    pub fn recvfrom(
        __fd: libc::c_int,
        __buf: *mut libc::c_void,
        __n: crate::stddef_h::size_t,
        __flags: libc::c_int,
        __addr: *mut crate::stdlib::sockaddr,
        __addr_len: *mut crate::stdlib::socklen_t,
    ) -> crate::stdlib::ssize_t;

    #[no_mangle]
    pub fn setsockopt(
        __fd: libc::c_int,
        __level: libc::c_int,
        __optname: libc::c_int,
        __optval: *const libc::c_void,
        __optlen: crate::stdlib::socklen_t,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn gettimeofday(
        __tv: *mut crate::stdlib::timeval,
        __tz: crate::stdlib::__timezone_ptr_t,
    ) -> libc::c_int;
    #[no_mangle]
    pub fn sysconf(__name: libc::c_int) -> libc::c_long;

    #[no_mangle]
    pub fn usleep(__useconds: crate::stdlib::__useconds_t) -> libc::c_int;

    #[no_mangle]
    pub fn close(__fd: libc::c_int) -> libc::c_int;

    #[no_mangle]
    pub fn read(
        __fd: libc::c_int,
        __buf: *mut libc::c_void,
        __nbytes: crate::stddef_h::size_t,
    ) -> crate::stdlib::ssize_t;

    #[no_mangle]
    pub fn sleep(__seconds: libc::c_uint) -> libc::c_uint;
}
// =============== BEGIN FILE_h ================
pub type FILE = crate::stdlib::_IO_FILE;
// ================ END FILE_h ================
// =============== BEGIN clockid_t_h ================
pub type clockid_t = crate::stdlib::__clockid_t;
// ================ END clockid_t_h ================
// =============== BEGIN codec_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vorbis_info {
    pub version: libc::c_int,
    pub channels: libc::c_int,
    pub rate: libc::c_long,
    pub bitrate_upper: libc::c_long,
    pub bitrate_nominal: libc::c_long,
    pub bitrate_lower: libc::c_long,
    pub bitrate_window: libc::c_long,
    pub codec_setup: *mut libc::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vorbis_comment {
    pub user_comments: *mut *mut libc::c_char,
    pub comment_lengths: *mut libc::c_int,
    pub comments: libc::c_int,
    pub vendor: *mut libc::c_char,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vorbis_dsp_state {
    pub analysisp: libc::c_int,
    pub vi: *mut crate::stdlib::vorbis_info,
    pub pcm: *mut *mut libc::c_float,
    pub pcmret: *mut *mut libc::c_float,
    pub pcm_storage: libc::c_int,
    pub pcm_current: libc::c_int,
    pub pcm_returned: libc::c_int,
    pub preextrapolate: libc::c_int,
    pub eofflag: libc::c_int,
    pub lW: libc::c_long,
    pub W: libc::c_long,
    pub nW: libc::c_long,
    pub centerW: libc::c_long,
    pub granulepos: crate::stdlib::ogg_int64_t,
    pub sequence: crate::stdlib::ogg_int64_t,
    pub glue_bits: crate::stdlib::ogg_int64_t,
    pub time_bits: crate::stdlib::ogg_int64_t,
    pub floor_bits: crate::stdlib::ogg_int64_t,
    pub res_bits: crate::stdlib::ogg_int64_t,
    pub backend_state: *mut libc::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct vorbis_block {
    pub pcm: *mut *mut libc::c_float,
    pub opb: crate::stdlib::oggpack_buffer,
    pub lW: libc::c_long,
    pub W: libc::c_long,
    pub nW: libc::c_long,
    pub pcmend: libc::c_int,
    pub mode: libc::c_int,
    pub eofflag: libc::c_int,
    pub granulepos: crate::stdlib::ogg_int64_t,
    pub sequence: crate::stdlib::ogg_int64_t,
    pub vd: *mut crate::stdlib::vorbis_dsp_state,
    pub localstore: *mut libc::c_void,
    pub localtop: libc::c_long,
    pub localalloc: libc::c_long,
    pub totaluse: libc::c_long,
    pub reap: *mut crate::stdlib::alloc_chain,
    pub glue_bits: libc::c_long,
    pub time_bits: libc::c_long,
    pub floor_bits: libc::c_long,
    pub res_bits: libc::c_long,
    pub internal: *mut libc::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct alloc_chain {
    pub ptr: *mut libc::c_void,
    pub next: *mut crate::stdlib::alloc_chain,
}
// ================ END codec_h ================
// =============== BEGIN config_types_h ================
pub type ogg_int64_t = crate::stdlib::int64_t;
// ================ END config_types_h ================
// =============== BEGIN confname_h ================
pub const _SC_THREAD_ROBUST_PRIO_PROTECT: crate::stdlib::C2RustUnnamed_0 = 248;
pub const _SC_THREAD_ROBUST_PRIO_INHERIT: crate::stdlib::C2RustUnnamed_0 = 247;
pub const _SC_XOPEN_STREAMS: crate::stdlib::C2RustUnnamed_0 = 246;
pub const _SC_TRACE_USER_EVENT_MAX: crate::stdlib::C2RustUnnamed_0 = 245;
pub const _SC_TRACE_SYS_MAX: crate::stdlib::C2RustUnnamed_0 = 244;
pub const _SC_TRACE_NAME_MAX: crate::stdlib::C2RustUnnamed_0 = 243;
pub const _SC_TRACE_EVENT_NAME_MAX: crate::stdlib::C2RustUnnamed_0 = 242;
pub const _SC_SS_REPL_MAX: crate::stdlib::C2RustUnnamed_0 = 241;
pub const _SC_V7_LPBIG_OFFBIG: crate::stdlib::C2RustUnnamed_0 = 240;
pub const _SC_V7_LP64_OFF64: crate::stdlib::C2RustUnnamed_0 = 239;
pub const _SC_V7_ILP32_OFFBIG: crate::stdlib::C2RustUnnamed_0 = 238;
pub const _SC_V7_ILP32_OFF32: crate::stdlib::C2RustUnnamed_0 = 237;
pub const _SC_RAW_SOCKETS: crate::stdlib::C2RustUnnamed_0 = 236;
pub const _SC_IPV6: crate::stdlib::C2RustUnnamed_0 = 235;
pub const _SC_LEVEL4_CACHE_LINESIZE: crate::stdlib::C2RustUnnamed_0 = 199;
pub const _SC_LEVEL4_CACHE_ASSOC: crate::stdlib::C2RustUnnamed_0 = 198;
pub const _SC_LEVEL4_CACHE_SIZE: crate::stdlib::C2RustUnnamed_0 = 197;
pub const _SC_LEVEL3_CACHE_LINESIZE: crate::stdlib::C2RustUnnamed_0 = 196;
pub const _SC_LEVEL3_CACHE_ASSOC: crate::stdlib::C2RustUnnamed_0 = 195;
pub const _SC_LEVEL3_CACHE_SIZE: crate::stdlib::C2RustUnnamed_0 = 194;
pub const _SC_LEVEL2_CACHE_LINESIZE: crate::stdlib::C2RustUnnamed_0 = 193;
pub const _SC_LEVEL2_CACHE_ASSOC: crate::stdlib::C2RustUnnamed_0 = 192;
pub const _SC_LEVEL2_CACHE_SIZE: crate::stdlib::C2RustUnnamed_0 = 191;
pub const _SC_LEVEL1_DCACHE_LINESIZE: crate::stdlib::C2RustUnnamed_0 = 190;
pub const _SC_LEVEL1_DCACHE_ASSOC: crate::stdlib::C2RustUnnamed_0 = 189;
pub const _SC_LEVEL1_DCACHE_SIZE: crate::stdlib::C2RustUnnamed_0 = 188;
pub const _SC_LEVEL1_ICACHE_LINESIZE: crate::stdlib::C2RustUnnamed_0 = 187;
pub const _SC_LEVEL1_ICACHE_ASSOC: crate::stdlib::C2RustUnnamed_0 = 186;
pub const _SC_LEVEL1_ICACHE_SIZE: crate::stdlib::C2RustUnnamed_0 = 185;
pub const _SC_TRACE_LOG: crate::stdlib::C2RustUnnamed_0 = 184;
pub const _SC_TRACE_INHERIT: crate::stdlib::C2RustUnnamed_0 = 183;
pub const _SC_TRACE_EVENT_FILTER: crate::stdlib::C2RustUnnamed_0 = 182;
pub const _SC_TRACE: crate::stdlib::C2RustUnnamed_0 = 181;
pub const _SC_HOST_NAME_MAX: crate::stdlib::C2RustUnnamed_0 = 180;
pub const _SC_V6_LPBIG_OFFBIG: crate::stdlib::C2RustUnnamed_0 = 179;
pub const _SC_V6_LP64_OFF64: crate::stdlib::C2RustUnnamed_0 = 178;
pub const _SC_V6_ILP32_OFFBIG: crate::stdlib::C2RustUnnamed_0 = 177;
pub const _SC_V6_ILP32_OFF32: crate::stdlib::C2RustUnnamed_0 = 176;
pub const _SC_2_PBS_CHECKPOINT: crate::stdlib::C2RustUnnamed_0 = 175;
pub const _SC_STREAMS: crate::stdlib::C2RustUnnamed_0 = 174;
pub const _SC_SYMLOOP_MAX: crate::stdlib::C2RustUnnamed_0 = 173;
pub const _SC_2_PBS_TRACK: crate::stdlib::C2RustUnnamed_0 = 172;
pub const _SC_2_PBS_MESSAGE: crate::stdlib::C2RustUnnamed_0 = 171;
pub const _SC_2_PBS_LOCATE: crate::stdlib::C2RustUnnamed_0 = 170;
pub const _SC_2_PBS_ACCOUNTING: crate::stdlib::C2RustUnnamed_0 = 169;
pub const _SC_2_PBS: crate::stdlib::C2RustUnnamed_0 = 168;
pub const _SC_USER_GROUPS_R: crate::stdlib::C2RustUnnamed_0 = 167;
pub const _SC_USER_GROUPS: crate::stdlib::C2RustUnnamed_0 = 166;
pub const _SC_TYPED_MEMORY_OBJECTS: crate::stdlib::C2RustUnnamed_0 = 165;
pub const _SC_TIMEOUTS: crate::stdlib::C2RustUnnamed_0 = 164;
pub const _SC_SYSTEM_DATABASE_R: crate::stdlib::C2RustUnnamed_0 = 163;
pub const _SC_SYSTEM_DATABASE: crate::stdlib::C2RustUnnamed_0 = 162;
pub const _SC_THREAD_SPORADIC_SERVER: crate::stdlib::C2RustUnnamed_0 = 161;
pub const _SC_SPORADIC_SERVER: crate::stdlib::C2RustUnnamed_0 = 160;
pub const _SC_SPAWN: crate::stdlib::C2RustUnnamed_0 = 159;
pub const _SC_SIGNALS: crate::stdlib::C2RustUnnamed_0 = 158;
pub const _SC_SHELL: crate::stdlib::C2RustUnnamed_0 = 157;
pub const _SC_REGEX_VERSION: crate::stdlib::C2RustUnnamed_0 = 156;
pub const _SC_REGEXP: crate::stdlib::C2RustUnnamed_0 = 155;
pub const _SC_SPIN_LOCKS: crate::stdlib::C2RustUnnamed_0 = 154;
pub const _SC_READER_WRITER_LOCKS: crate::stdlib::C2RustUnnamed_0 = 153;
pub const _SC_NETWORKING: crate::stdlib::C2RustUnnamed_0 = 152;
pub const _SC_SINGLE_PROCESS: crate::stdlib::C2RustUnnamed_0 = 151;
pub const _SC_MULTI_PROCESS: crate::stdlib::C2RustUnnamed_0 = 150;
pub const _SC_MONOTONIC_CLOCK: crate::stdlib::C2RustUnnamed_0 = 149;
pub const _SC_FILE_SYSTEM: crate::stdlib::C2RustUnnamed_0 = 148;
pub const _SC_FILE_LOCKING: crate::stdlib::C2RustUnnamed_0 = 147;
pub const _SC_FILE_ATTRIBUTES: crate::stdlib::C2RustUnnamed_0 = 146;
pub const _SC_PIPE: crate::stdlib::C2RustUnnamed_0 = 145;
pub const _SC_FIFO: crate::stdlib::C2RustUnnamed_0 = 144;
pub const _SC_FD_MGMT: crate::stdlib::C2RustUnnamed_0 = 143;
pub const _SC_DEVICE_SPECIFIC_R: crate::stdlib::C2RustUnnamed_0 = 142;
pub const _SC_DEVICE_SPECIFIC: crate::stdlib::C2RustUnnamed_0 = 141;
pub const _SC_DEVICE_IO: crate::stdlib::C2RustUnnamed_0 = 140;
pub const _SC_THREAD_CPUTIME: crate::stdlib::C2RustUnnamed_0 = 139;
pub const _SC_CPUTIME: crate::stdlib::C2RustUnnamed_0 = 138;
pub const _SC_CLOCK_SELECTION: crate::stdlib::C2RustUnnamed_0 = 137;
pub const _SC_C_LANG_SUPPORT_R: crate::stdlib::C2RustUnnamed_0 = 136;
pub const _SC_C_LANG_SUPPORT: crate::stdlib::C2RustUnnamed_0 = 135;
pub const _SC_BASE: crate::stdlib::C2RustUnnamed_0 = 134;
pub const _SC_BARRIERS: crate::stdlib::C2RustUnnamed_0 = 133;
pub const _SC_ADVISORY_INFO: crate::stdlib::C2RustUnnamed_0 = 132;
pub const _SC_XOPEN_REALTIME_THREADS: crate::stdlib::C2RustUnnamed_0 = 131;
pub const _SC_XOPEN_REALTIME: crate::stdlib::C2RustUnnamed_0 = 130;
pub const _SC_XOPEN_LEGACY: crate::stdlib::C2RustUnnamed_0 = 129;
pub const _SC_XBS5_LPBIG_OFFBIG: crate::stdlib::C2RustUnnamed_0 = 128;
pub const _SC_XBS5_LP64_OFF64: crate::stdlib::C2RustUnnamed_0 = 127;
pub const _SC_XBS5_ILP32_OFFBIG: crate::stdlib::C2RustUnnamed_0 = 126;
pub const _SC_XBS5_ILP32_OFF32: crate::stdlib::C2RustUnnamed_0 = 125;
pub const _SC_NL_TEXTMAX: crate::stdlib::C2RustUnnamed_0 = 124;
pub const _SC_NL_SETMAX: crate::stdlib::C2RustUnnamed_0 = 123;
pub const _SC_NL_NMAX: crate::stdlib::C2RustUnnamed_0 = 122;
pub const _SC_NL_MSGMAX: crate::stdlib::C2RustUnnamed_0 = 121;
pub const _SC_NL_LANGMAX: crate::stdlib::C2RustUnnamed_0 = 120;
pub const _SC_NL_ARGMAX: crate::stdlib::C2RustUnnamed_0 = 119;
pub const _SC_USHRT_MAX: crate::stdlib::C2RustUnnamed_0 = 118;
pub const _SC_ULONG_MAX: crate::stdlib::C2RustUnnamed_0 = 117;
pub const _SC_UINT_MAX: crate::stdlib::C2RustUnnamed_0 = 116;
pub const _SC_UCHAR_MAX: crate::stdlib::C2RustUnnamed_0 = 115;
pub const _SC_SHRT_MIN: crate::stdlib::C2RustUnnamed_0 = 114;
pub const _SC_SHRT_MAX: crate::stdlib::C2RustUnnamed_0 = 113;
pub const _SC_SCHAR_MIN: crate::stdlib::C2RustUnnamed_0 = 112;
pub const _SC_SCHAR_MAX: crate::stdlib::C2RustUnnamed_0 = 111;
pub const _SC_SSIZE_MAX: crate::stdlib::C2RustUnnamed_0 = 110;
pub const _SC_NZERO: crate::stdlib::C2RustUnnamed_0 = 109;
pub const _SC_MB_LEN_MAX: crate::stdlib::C2RustUnnamed_0 = 108;
pub const _SC_WORD_BIT: crate::stdlib::C2RustUnnamed_0 = 107;
pub const _SC_LONG_BIT: crate::stdlib::C2RustUnnamed_0 = 106;
pub const _SC_INT_MIN: crate::stdlib::C2RustUnnamed_0 = 105;
pub const _SC_INT_MAX: crate::stdlib::C2RustUnnamed_0 = 104;
pub const _SC_CHAR_MIN: crate::stdlib::C2RustUnnamed_0 = 103;
pub const _SC_CHAR_MAX: crate::stdlib::C2RustUnnamed_0 = 102;
pub const _SC_CHAR_BIT: crate::stdlib::C2RustUnnamed_0 = 101;
pub const _SC_XOPEN_XPG4: crate::stdlib::C2RustUnnamed_0 = 100;
pub const _SC_XOPEN_XPG3: crate::stdlib::C2RustUnnamed_0 = 99;
pub const _SC_XOPEN_XPG2: crate::stdlib::C2RustUnnamed_0 = 98;
pub const _SC_2_UPE: crate::stdlib::C2RustUnnamed_0 = 97;
pub const _SC_2_C_VERSION: crate::stdlib::C2RustUnnamed_0 = 96;
pub const _SC_2_CHAR_TERM: crate::stdlib::C2RustUnnamed_0 = 95;
pub const _SC_XOPEN_SHM: crate::stdlib::C2RustUnnamed_0 = 94;
pub const _SC_XOPEN_ENH_I18N: crate::stdlib::C2RustUnnamed_0 = 93;
pub const _SC_XOPEN_CRYPT: crate::stdlib::C2RustUnnamed_0 = 92;
pub const _SC_XOPEN_UNIX: crate::stdlib::C2RustUnnamed_0 = 91;
pub const _SC_XOPEN_XCU_VERSION: crate::stdlib::C2RustUnnamed_0 = 90;
pub const _SC_XOPEN_VERSION: crate::stdlib::C2RustUnnamed_0 = 89;
pub const _SC_PASS_MAX: crate::stdlib::C2RustUnnamed_0 = 88;
pub const _SC_ATEXIT_MAX: crate::stdlib::C2RustUnnamed_0 = 87;
pub const _SC_AVPHYS_PAGES: crate::stdlib::C2RustUnnamed_0 = 86;
pub const _SC_PHYS_PAGES: crate::stdlib::C2RustUnnamed_0 = 85;
pub const _SC_NPROCESSORS_ONLN: crate::stdlib::C2RustUnnamed_0 = 84;
pub const _SC_NPROCESSORS_CONF: crate::stdlib::C2RustUnnamed_0 = 83;
pub const _SC_THREAD_PROCESS_SHARED: crate::stdlib::C2RustUnnamed_0 = 82;
pub const _SC_THREAD_PRIO_PROTECT: crate::stdlib::C2RustUnnamed_0 = 81;
pub const _SC_THREAD_PRIO_INHERIT: crate::stdlib::C2RustUnnamed_0 = 80;
pub const _SC_THREAD_PRIORITY_SCHEDULING: crate::stdlib::C2RustUnnamed_0 = 79;
pub const _SC_THREAD_ATTR_STACKSIZE: crate::stdlib::C2RustUnnamed_0 = 78;
pub const _SC_THREAD_ATTR_STACKADDR: crate::stdlib::C2RustUnnamed_0 = 77;
pub const _SC_THREAD_THREADS_MAX: crate::stdlib::C2RustUnnamed_0 = 76;
pub const _SC_THREAD_STACK_MIN: crate::stdlib::C2RustUnnamed_0 = 75;
pub const _SC_THREAD_KEYS_MAX: crate::stdlib::C2RustUnnamed_0 = 74;
pub const _SC_THREAD_DESTRUCTOR_ITERATIONS: crate::stdlib::C2RustUnnamed_0 = 73;
pub const _SC_TTY_NAME_MAX: crate::stdlib::C2RustUnnamed_0 = 72;
pub const _SC_LOGIN_NAME_MAX: crate::stdlib::C2RustUnnamed_0 = 71;
pub const _SC_GETPW_R_SIZE_MAX: crate::stdlib::C2RustUnnamed_0 = 70;
pub const _SC_GETGR_R_SIZE_MAX: crate::stdlib::C2RustUnnamed_0 = 69;
pub const _SC_THREAD_SAFE_FUNCTIONS: crate::stdlib::C2RustUnnamed_0 = 68;
pub const _SC_THREADS: crate::stdlib::C2RustUnnamed_0 = 67;
pub const _SC_T_IOV_MAX: crate::stdlib::C2RustUnnamed_0 = 66;
pub const _SC_PII_OSI_M: crate::stdlib::C2RustUnnamed_0 = 65;
pub const _SC_PII_OSI_CLTS: crate::stdlib::C2RustUnnamed_0 = 64;
pub const _SC_PII_OSI_COTS: crate::stdlib::C2RustUnnamed_0 = 63;
pub const _SC_PII_INTERNET_DGRAM: crate::stdlib::C2RustUnnamed_0 = 62;
pub const _SC_PII_INTERNET_STREAM: crate::stdlib::C2RustUnnamed_0 = 61;
pub const _SC_IOV_MAX: crate::stdlib::C2RustUnnamed_0 = 60;
pub const _SC_UIO_MAXIOV: crate::stdlib::C2RustUnnamed_0 = 60;
pub const _SC_SELECT: crate::stdlib::C2RustUnnamed_0 = 59;
pub const _SC_POLL: crate::stdlib::C2RustUnnamed_0 = 58;
pub const _SC_PII_OSI: crate::stdlib::C2RustUnnamed_0 = 57;
pub const _SC_PII_INTERNET: crate::stdlib::C2RustUnnamed_0 = 56;
pub const _SC_PII_SOCKET: crate::stdlib::C2RustUnnamed_0 = 55;
pub const _SC_PII_XTI: crate::stdlib::C2RustUnnamed_0 = 54;
pub const _SC_PII: crate::stdlib::C2RustUnnamed_0 = 53;
pub const _SC_2_LOCALEDEF: crate::stdlib::C2RustUnnamed_0 = 52;
pub const _SC_2_SW_DEV: crate::stdlib::C2RustUnnamed_0 = 51;
pub const _SC_2_FORT_RUN: crate::stdlib::C2RustUnnamed_0 = 50;
pub const _SC_2_FORT_DEV: crate::stdlib::C2RustUnnamed_0 = 49;
pub const _SC_2_C_DEV: crate::stdlib::C2RustUnnamed_0 = 48;
pub const _SC_2_C_BIND: crate::stdlib::C2RustUnnamed_0 = 47;
pub const _SC_2_VERSION: crate::stdlib::C2RustUnnamed_0 = 46;
pub const _SC_CHARCLASS_NAME_MAX: crate::stdlib::C2RustUnnamed_0 = 45;
pub const _SC_RE_DUP_MAX: crate::stdlib::C2RustUnnamed_0 = 44;
pub const _SC_LINE_MAX: crate::stdlib::C2RustUnnamed_0 = 43;
pub const _SC_EXPR_NEST_MAX: crate::stdlib::C2RustUnnamed_0 = 42;
pub const _SC_EQUIV_CLASS_MAX: crate::stdlib::C2RustUnnamed_0 = 41;
pub const _SC_COLL_WEIGHTS_MAX: crate::stdlib::C2RustUnnamed_0 = 40;
pub const _SC_BC_STRING_MAX: crate::stdlib::C2RustUnnamed_0 = 39;
pub const _SC_BC_SCALE_MAX: crate::stdlib::C2RustUnnamed_0 = 38;
pub const _SC_BC_DIM_MAX: crate::stdlib::C2RustUnnamed_0 = 37;
pub const _SC_BC_BASE_MAX: crate::stdlib::C2RustUnnamed_0 = 36;
pub const _SC_TIMER_MAX: crate::stdlib::C2RustUnnamed_0 = 35;
pub const _SC_SIGQUEUE_MAX: crate::stdlib::C2RustUnnamed_0 = 34;
pub const _SC_SEM_VALUE_MAX: crate::stdlib::C2RustUnnamed_0 = 33;
pub const _SC_SEM_NSEMS_MAX: crate::stdlib::C2RustUnnamed_0 = 32;
pub const _SC_RTSIG_MAX: crate::stdlib::C2RustUnnamed_0 = 31;
pub const _SC_PAGESIZE: crate::stdlib::C2RustUnnamed_0 = 30;
pub const _SC_VERSION: crate::stdlib::C2RustUnnamed_0 = 29;
pub const _SC_MQ_PRIO_MAX: crate::stdlib::C2RustUnnamed_0 = 28;
pub const _SC_MQ_OPEN_MAX: crate::stdlib::C2RustUnnamed_0 = 27;
pub const _SC_DELAYTIMER_MAX: crate::stdlib::C2RustUnnamed_0 = 26;
pub const _SC_AIO_PRIO_DELTA_MAX: crate::stdlib::C2RustUnnamed_0 = 25;
pub const _SC_AIO_MAX: crate::stdlib::C2RustUnnamed_0 = 24;
pub const _SC_AIO_LISTIO_MAX: crate::stdlib::C2RustUnnamed_0 = 23;
pub const _SC_SHARED_MEMORY_OBJECTS: crate::stdlib::C2RustUnnamed_0 = 22;
pub const _SC_SEMAPHORES: crate::stdlib::C2RustUnnamed_0 = 21;
pub const _SC_MESSAGE_PASSING: crate::stdlib::C2RustUnnamed_0 = 20;
pub const _SC_MEMORY_PROTECTION: crate::stdlib::C2RustUnnamed_0 = 19;
pub const _SC_MEMLOCK_RANGE: crate::stdlib::C2RustUnnamed_0 = 18;
pub const _SC_MEMLOCK: crate::stdlib::C2RustUnnamed_0 = 17;
pub const _SC_MAPPED_FILES: crate::stdlib::C2RustUnnamed_0 = 16;
pub const _SC_FSYNC: crate::stdlib::C2RustUnnamed_0 = 15;
pub const _SC_SYNCHRONIZED_IO: crate::stdlib::C2RustUnnamed_0 = 14;
pub const _SC_PRIORITIZED_IO: crate::stdlib::C2RustUnnamed_0 = 13;
pub const _SC_ASYNCHRONOUS_IO: crate::stdlib::C2RustUnnamed_0 = 12;
pub const _SC_TIMERS: crate::stdlib::C2RustUnnamed_0 = 11;
pub const _SC_PRIORITY_SCHEDULING: crate::stdlib::C2RustUnnamed_0 = 10;
pub const _SC_REALTIME_SIGNALS: crate::stdlib::C2RustUnnamed_0 = 9;
pub const _SC_SAVED_IDS: crate::stdlib::C2RustUnnamed_0 = 8;
pub const _SC_JOB_CONTROL: crate::stdlib::C2RustUnnamed_0 = 7;
pub const _SC_TZNAME_MAX: crate::stdlib::C2RustUnnamed_0 = 6;
pub const _SC_STREAM_MAX: crate::stdlib::C2RustUnnamed_0 = 5;
pub const _SC_OPEN_MAX: crate::stdlib::C2RustUnnamed_0 = 4;
pub const _SC_NGROUPS_MAX: crate::stdlib::C2RustUnnamed_0 = 3;
pub const _SC_CLK_TCK: crate::stdlib::C2RustUnnamed_0 = 2;
pub const _SC_CHILD_MAX: crate::stdlib::C2RustUnnamed_0 = 1;
pub const _SC_ARG_MAX: crate::stdlib::C2RustUnnamed_0 = 0;
// ================ END confname_h ================
// =============== BEGIN error_h ================
pub type snd_lib_error_handler_t = Option<
    unsafe extern "C" fn(
        _: *const libc::c_char,
        _: libc::c_int,
        _: *const libc::c_char,
        _: libc::c_int,
        _: *const libc::c_char,
        _: ...
    ) -> (),
>;
// ================ END error_h ================
// =============== BEGIN eventfd_h ================
pub type eventfd_t = crate::stdlib::uint64_t;
// ================ END eventfd_h ================
// =============== BEGIN fmt123_h ================
pub type mpg123_enc_enum = libc::c_uint;
pub const MPG123_ENC_SIGNED_32: crate::stdlib::mpg123_enc_enum = 4480;
pub const MPG123_ENC_SIGNED_16: crate::stdlib::mpg123_enc_enum = 208;
pub const MPG123_ENC_ANY: crate::stdlib::mpg123_enc_enum = 30719;
pub const MPG123_ENC_FLOAT_64: crate::stdlib::mpg123_enc_enum = 1024;
pub const MPG123_ENC_FLOAT_32: crate::stdlib::mpg123_enc_enum = 512;
pub const MPG123_ENC_UNSIGNED_24: crate::stdlib::mpg123_enc_enum = 24576;
pub const MPG123_ENC_SIGNED_24: crate::stdlib::mpg123_enc_enum = 20608;
pub const MPG123_ENC_UNSIGNED_32: crate::stdlib::mpg123_enc_enum = 8448;
pub const MPG123_ENC_ALAW_8: crate::stdlib::mpg123_enc_enum = 8;
pub const MPG123_ENC_ULAW_8: crate::stdlib::mpg123_enc_enum = 4;
pub const MPG123_ENC_SIGNED_8: crate::stdlib::mpg123_enc_enum = 130;
pub const MPG123_ENC_UNSIGNED_8: crate::stdlib::mpg123_enc_enum = 1;
pub const MPG123_ENC_UNSIGNED_16: crate::stdlib::mpg123_enc_enum = 96;
pub const MPG123_ENC_FLOAT: crate::stdlib::mpg123_enc_enum = 3584;
pub const MPG123_ENC_SIGNED: crate::stdlib::mpg123_enc_enum = 128;
pub const MPG123_ENC_32: crate::stdlib::mpg123_enc_enum = 256;
pub const MPG123_ENC_24: crate::stdlib::mpg123_enc_enum = 16384;
pub const MPG123_ENC_16: crate::stdlib::mpg123_enc_enum = 64;
pub const MPG123_ENC_8: crate::stdlib::mpg123_enc_enum = 15;
// ================ END fmt123_h ================
// =============== BEGIN format_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_4 {
    pub stream_info: crate::stdlib::FLAC__StreamMetadata_StreamInfo,
    pub padding: crate::stdlib::FLAC__StreamMetadata_Padding,
    pub application: crate::stdlib::FLAC__StreamMetadata_Application,
    pub seek_table: crate::stdlib::FLAC__StreamMetadata_SeekTable,
    pub vorbis_comment: crate::stdlib::FLAC__StreamMetadata_VorbisComment,
    pub cue_sheet: crate::stdlib::FLAC__StreamMetadata_CueSheet,
    pub picture: crate::stdlib::FLAC__StreamMetadata_Picture,
    pub unknown: crate::stdlib::FLAC__StreamMetadata_Unknown,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_5 {
    pub constant: crate::stdlib::FLAC__Subframe_Constant,
    pub fixed: crate::stdlib::FLAC__Subframe_Fixed,
    pub lpc: crate::stdlib::FLAC__Subframe_LPC,
    pub verbatim: crate::stdlib::FLAC__Subframe_Verbatim,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_6 {
    pub partitioned_rice: crate::stdlib::FLAC__EntropyCodingMethod_PartitionedRice,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_7 {
    pub frame_number: crate::stdlib::FLAC__uint32,
    pub sample_number: crate::stdlib::FLAC__uint64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata {
    pub type_0: crate::stdlib::FLAC__MetadataType,
    pub is_last: crate::stdlib::FLAC__bool,
    pub length: crate::stdlib::uint32_t,
    pub data: crate::stdlib::C2RustUnnamed_4,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__Frame {
    pub header: crate::stdlib::FLAC__FrameHeader,
    pub subframes: [crate::stdlib::FLAC__Subframe; 8],
    pub footer: crate::stdlib::FLAC__FrameFooter,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_Unknown {
    pub data: *mut crate::stdlib::FLAC__byte,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_Picture {
    pub type_0: crate::stdlib::FLAC__StreamMetadata_Picture_Type,
    pub mime_type: *mut libc::c_char,
    pub description: *mut crate::stdlib::FLAC__byte,
    pub width: crate::stdlib::FLAC__uint32,
    pub height: crate::stdlib::FLAC__uint32,
    pub depth: crate::stdlib::FLAC__uint32,
    pub colors: crate::stdlib::FLAC__uint32,
    pub data_length: crate::stdlib::FLAC__uint32,
    pub data: *mut crate::stdlib::FLAC__byte,
}
pub type FLAC__StreamMetadata_Picture_Type = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_CueSheet {
    pub media_catalog_number: [libc::c_char; 129],
    pub lead_in: crate::stdlib::FLAC__uint64,
    pub is_cd: crate::stdlib::FLAC__bool,
    pub num_tracks: crate::stdlib::uint32_t,
    pub tracks: *mut crate::stdlib::FLAC__StreamMetadata_CueSheet_Track,
}
#[repr(C)]
#[derive(Copy, Clone, BitfieldStruct)]
pub struct FLAC__StreamMetadata_CueSheet_Track {
    pub offset: crate::stdlib::FLAC__uint64,
    pub number: crate::stdlib::FLAC__byte,
    pub isrc: [libc::c_char; 13],
    #[bitfield(name = "type_0", ty = "uint32_t", bits = "0..=0")]
    #[bitfield(name = "pre_emphasis", ty = "uint32_t", bits = "1..=1")]
    pub type_0_pre_emphasis: [u8; 1],
    pub num_indices: crate::stdlib::FLAC__byte,
    pub indices: *mut crate::stdlib::FLAC__StreamMetadata_CueSheet_Index,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_CueSheet_Index {
    pub offset: crate::stdlib::FLAC__uint64,
    pub number: crate::stdlib::FLAC__byte,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_VorbisComment {
    pub vendor_string: crate::stdlib::FLAC__StreamMetadata_VorbisComment_Entry,
    pub num_comments: crate::stdlib::FLAC__uint32,
    pub comments: *mut crate::stdlib::FLAC__StreamMetadata_VorbisComment_Entry,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_VorbisComment_Entry {
    pub length: crate::stdlib::FLAC__uint32,
    pub entry: *mut crate::stdlib::FLAC__byte,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_SeekTable {
    pub num_points: crate::stdlib::uint32_t,
    pub points: *mut crate::stdlib::FLAC__StreamMetadata_SeekPoint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_SeekPoint {
    pub sample_number: crate::stdlib::FLAC__uint64,
    pub stream_offset: crate::stdlib::FLAC__uint64,
    pub frame_samples: crate::stdlib::uint32_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_Application {
    pub id: [crate::stdlib::FLAC__byte; 4],
    pub data: *mut crate::stdlib::FLAC__byte,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_Padding {
    pub dummy: libc::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamMetadata_StreamInfo {
    pub min_blocksize: crate::stdlib::uint32_t,
    pub max_blocksize: crate::stdlib::uint32_t,
    pub min_framesize: crate::stdlib::uint32_t,
    pub max_framesize: crate::stdlib::uint32_t,
    pub sample_rate: crate::stdlib::uint32_t,
    pub channels: crate::stdlib::uint32_t,
    pub bits_per_sample: crate::stdlib::uint32_t,
    pub total_samples: crate::stdlib::FLAC__uint64,
    pub md5sum: [crate::stdlib::FLAC__byte; 16],
}
pub type FLAC__MetadataType = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__FrameFooter {
    pub crc: crate::stdlib::FLAC__uint16,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__Subframe {
    pub type_0: crate::stdlib::FLAC__SubframeType,
    pub data: crate::stdlib::C2RustUnnamed_5,
    pub wasted_bits: crate::stdlib::uint32_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__Subframe_Verbatim {
    pub data: *const crate::stdlib::FLAC__int32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__Subframe_LPC {
    pub entropy_coding_method: crate::stdlib::FLAC__EntropyCodingMethod,
    pub order: crate::stdlib::uint32_t,
    pub qlp_coeff_precision: crate::stdlib::uint32_t,
    pub quantization_level: libc::c_int,
    pub qlp_coeff: [crate::stdlib::FLAC__int32; 32],
    pub warmup: [crate::stdlib::FLAC__int32; 32],
    pub residual: *const crate::stdlib::FLAC__int32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__EntropyCodingMethod {
    pub type_0: crate::stdlib::FLAC__EntropyCodingMethodType,
    pub data: crate::stdlib::C2RustUnnamed_6,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__EntropyCodingMethod_PartitionedRice {
    pub order: crate::stdlib::uint32_t,
    pub contents: *const crate::stdlib::FLAC__EntropyCodingMethod_PartitionedRiceContents,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__EntropyCodingMethod_PartitionedRiceContents {
    pub parameters: *mut crate::stdlib::uint32_t,
    pub raw_bits: *mut crate::stdlib::uint32_t,
    pub capacity_by_order: crate::stdlib::uint32_t,
}
pub type FLAC__EntropyCodingMethodType = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__Subframe_Fixed {
    pub entropy_coding_method: crate::stdlib::FLAC__EntropyCodingMethod,
    pub order: crate::stdlib::uint32_t,
    pub warmup: [crate::stdlib::FLAC__int32; 4],
    pub residual: *const crate::stdlib::FLAC__int32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__Subframe_Constant {
    pub value: crate::stdlib::FLAC__int32,
}
pub type FLAC__SubframeType = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__FrameHeader {
    pub blocksize: crate::stdlib::uint32_t,
    pub sample_rate: crate::stdlib::uint32_t,
    pub channels: crate::stdlib::uint32_t,
    pub channel_assignment: crate::stdlib::FLAC__ChannelAssignment,
    pub bits_per_sample: crate::stdlib::uint32_t,
    pub number_type: crate::stdlib::FLAC__FrameNumberType,
    pub number: crate::stdlib::C2RustUnnamed_7,
    pub crc: crate::stdlib::FLAC__uint8,
}
pub type FLAC__FrameNumberType = libc::c_uint;
pub type FLAC__ChannelAssignment = libc::c_uint;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_UNDEFINED:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 21;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_PUBLISHER_LOGOTYPE:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 20;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_BAND_LOGOTYPE:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 19;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_ILLUSTRATION:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 18;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_FISH:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 17;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_VIDEO_SCREEN_CAPTURE:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 16;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_DURING_PERFORMANCE:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 15;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_DURING_RECORDING:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 14;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_RECORDING_LOCATION:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 13;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_LYRICIST:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 12;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_COMPOSER:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 11;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_BAND:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 10;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_CONDUCTOR:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 9;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_ARTIST:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 8;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_LEAD_ARTIST:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 7;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_MEDIA:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 6;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_LEAFLET_PAGE:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 5;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_BACK_COVER:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 4;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_FRONT_COVER:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 3;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_FILE_ICON:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 2;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_FILE_ICON_STANDARD:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 1;
pub const FLAC__STREAM_METADATA_PICTURE_TYPE_OTHER:
    crate::stdlib::FLAC__StreamMetadata_Picture_Type = 0;
pub const FLAC__MAX_METADATA_TYPE: crate::stdlib::FLAC__MetadataType = 126;
pub const FLAC__METADATA_TYPE_UNDEFINED: crate::stdlib::FLAC__MetadataType = 7;
pub const FLAC__METADATA_TYPE_PICTURE: crate::stdlib::FLAC__MetadataType = 6;
pub const FLAC__METADATA_TYPE_CUESHEET: crate::stdlib::FLAC__MetadataType = 5;
pub const FLAC__METADATA_TYPE_VORBIS_COMMENT: crate::stdlib::FLAC__MetadataType = 4;
pub const FLAC__METADATA_TYPE_SEEKTABLE: crate::stdlib::FLAC__MetadataType = 3;
pub const FLAC__METADATA_TYPE_APPLICATION: crate::stdlib::FLAC__MetadataType = 2;
pub const FLAC__METADATA_TYPE_PADDING: crate::stdlib::FLAC__MetadataType = 1;
pub const FLAC__METADATA_TYPE_STREAMINFO: crate::stdlib::FLAC__MetadataType = 0;
pub const FLAC__ENTROPY_CODING_METHOD_PARTITIONED_RICE2:
    crate::stdlib::FLAC__EntropyCodingMethodType = 1;
pub const FLAC__ENTROPY_CODING_METHOD_PARTITIONED_RICE:
    crate::stdlib::FLAC__EntropyCodingMethodType = 0;
pub const FLAC__SUBFRAME_TYPE_LPC: crate::stdlib::FLAC__SubframeType = 3;
pub const FLAC__SUBFRAME_TYPE_FIXED: crate::stdlib::FLAC__SubframeType = 2;
pub const FLAC__SUBFRAME_TYPE_VERBATIM: crate::stdlib::FLAC__SubframeType = 1;
pub const FLAC__SUBFRAME_TYPE_CONSTANT: crate::stdlib::FLAC__SubframeType = 0;
pub const FLAC__FRAME_NUMBER_TYPE_SAMPLE_NUMBER: crate::stdlib::FLAC__FrameNumberType = 1;
pub const FLAC__FRAME_NUMBER_TYPE_FRAME_NUMBER: crate::stdlib::FLAC__FrameNumberType = 0;
pub const FLAC__CHANNEL_ASSIGNMENT_MID_SIDE: crate::stdlib::FLAC__ChannelAssignment = 3;
pub const FLAC__CHANNEL_ASSIGNMENT_RIGHT_SIDE: crate::stdlib::FLAC__ChannelAssignment = 2;
pub const FLAC__CHANNEL_ASSIGNMENT_LEFT_SIDE: crate::stdlib::FLAC__ChannelAssignment = 1;
pub const FLAC__CHANNEL_ASSIGNMENT_INDEPENDENT: crate::stdlib::FLAC__ChannelAssignment = 0;
// ================ END format_h ================
// =============== BEGIN if_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_20 {
    pub ifru_addr: crate::stdlib::sockaddr,
    pub ifru_dstaddr: crate::stdlib::sockaddr,
    pub ifru_broadaddr: crate::stdlib::sockaddr,
    pub ifru_netmask: crate::stdlib::sockaddr,
    pub ifru_hwaddr: crate::stdlib::sockaddr,
    pub ifru_flags: libc::c_short,
    pub ifru_ivalue: libc::c_int,
    pub ifru_mtu: libc::c_int,
    pub ifru_map: crate::stdlib::ifmap,
    pub ifru_slave: [libc::c_char; 16],
    pub ifru_newname: [libc::c_char; 16],
    pub ifru_data: crate::stdlib::__caddr_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_21 {
    pub ifrn_name: [libc::c_char; 16],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_22 {
    pub ifcu_buf: crate::stdlib::__caddr_t,
    pub ifcu_req: *mut crate::stdlib::ifreq,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ifmap {
    pub mem_start: libc::c_ulong,
    pub mem_end: libc::c_ulong,
    pub base_addr: libc::c_ushort,
    pub irq: libc::c_uchar,
    pub dma: libc::c_uchar,
    pub port: libc::c_uchar,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ifreq {
    pub ifr_ifrn: crate::stdlib::C2RustUnnamed_21,
    pub ifr_ifru: crate::stdlib::C2RustUnnamed_20,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ifconf {
    pub ifc_len: libc::c_int,
    pub ifc_ifcu: crate::stdlib::C2RustUnnamed_22,
}
// ================ END if_h ================
// =============== BEGIN in_h ================
pub type in_addr_t = crate::stdlib::uint32_t;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct in_addr {
    pub s_addr: crate::stdlib::in_addr_t,
}
pub type in_port_t = crate::stdlib::uint16_t;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sockaddr_in {
    pub sin_family: crate::stdlib::sa_family_t,
    pub sin_port: crate::stdlib::in_port_t,
    pub sin_addr: crate::stdlib::in_addr,
    pub sin_zero: [libc::c_uchar; 8],
}
// ================ END in_h ================
// =============== BEGIN mad_h ================
pub type mad_fixed_t = libc::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad_stream {
    pub buffer: *const libc::c_uchar,
    pub bufend: *const libc::c_uchar,
    pub skiplen: libc::c_ulong,
    pub sync: libc::c_int,
    pub freerate: libc::c_ulong,
    pub this_frame: *const libc::c_uchar,
    pub next_frame: *const libc::c_uchar,
    pub ptr: crate::stdlib::mad_bitptr,
    pub anc_ptr: crate::stdlib::mad_bitptr,
    pub anc_bitlen: libc::c_uint,
    pub main_data: *mut [libc::c_uchar; 2567],
    pub md_len: libc::c_uint,
    pub options: libc::c_int,
    pub error: crate::stdlib::mad_error,
}
pub type mad_error = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad_bitptr {
    pub byte: *const libc::c_uchar,
    pub cache: libc::c_ushort,
    pub left: libc::c_ushort,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad_frame {
    pub header: crate::stdlib::mad_header,
    pub options: libc::c_int,
    pub sbsample: [[[crate::stdlib::mad_fixed_t; 32]; 36]; 2],
    pub overlap: *mut [[[crate::stdlib::mad_fixed_t; 18]; 32]; 2],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad_header {
    pub layer: crate::stdlib::mad_layer,
    pub mode: crate::stdlib::mad_mode,
    pub mode_extension: libc::c_int,
    pub emphasis: crate::stdlib::mad_emphasis,
    pub bitrate: libc::c_ulong,
    pub samplerate: libc::c_uint,
    pub crc_check: libc::c_ushort,
    pub crc_target: libc::c_ushort,
    pub flags: libc::c_int,
    pub private_bits: libc::c_int,
    pub duration: crate::stdlib::mad_timer_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad_timer_t {
    pub seconds: libc::c_long,
    pub fraction: libc::c_ulong,
}
pub type mad_emphasis = libc::c_uint;
pub type mad_mode = libc::c_uint;
pub type mad_layer = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad_synth {
    pub filter: [[[[[crate::stdlib::mad_fixed_t; 8]; 16]; 2]; 2]; 2],
    pub phase: libc::c_uint,
    pub pcm: crate::stdlib::mad_pcm,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct mad_pcm {
    pub samplerate: libc::c_uint,
    pub channels: libc::c_ushort,
    pub length: libc::c_ushort,
    pub samples: [[crate::stdlib::mad_fixed_t; 1152]; 2],
}
pub const MAD_ERROR_BADSTEREO: crate::stdlib::mad_error = 569;
pub const MAD_ERROR_BADHUFFDATA: crate::stdlib::mad_error = 568;
pub const MAD_ERROR_BADHUFFTABLE: crate::stdlib::mad_error = 567;
pub const MAD_ERROR_BADPART3LEN: crate::stdlib::mad_error = 566;
pub const MAD_ERROR_BADDATAPTR: crate::stdlib::mad_error = 565;
pub const MAD_ERROR_BADSCFSI: crate::stdlib::mad_error = 564;
pub const MAD_ERROR_BADBLOCKTYPE: crate::stdlib::mad_error = 563;
pub const MAD_ERROR_BADBIGVALUES: crate::stdlib::mad_error = 562;
pub const MAD_ERROR_BADFRAMELEN: crate::stdlib::mad_error = 561;
pub const MAD_ERROR_BADMODE: crate::stdlib::mad_error = 546;
pub const MAD_ERROR_BADSCALEFACTOR: crate::stdlib::mad_error = 545;
pub const MAD_ERROR_BADBITALLOC: crate::stdlib::mad_error = 529;
pub const MAD_ERROR_BADCRC: crate::stdlib::mad_error = 513;
pub const MAD_ERROR_BADEMPHASIS: crate::stdlib::mad_error = 261;
pub const MAD_ERROR_BADSAMPLERATE: crate::stdlib::mad_error = 260;
pub const MAD_ERROR_BADBITRATE: crate::stdlib::mad_error = 259;
pub const MAD_ERROR_BADLAYER: crate::stdlib::mad_error = 258;
pub const MAD_ERROR_LOSTSYNC: crate::stdlib::mad_error = 257;
pub const MAD_ERROR_NOMEM: crate::stdlib::mad_error = 49;
pub const MAD_ERROR_BUFPTR: crate::stdlib::mad_error = 2;
pub const MAD_ERROR_BUFLEN: crate::stdlib::mad_error = 1;
pub const MAD_ERROR_NONE: crate::stdlib::mad_error = 0;
pub const MAD_EMPHASIS_RESERVED: crate::stdlib::mad_emphasis = 2;
pub const MAD_EMPHASIS_CCITT_J_17: crate::stdlib::mad_emphasis = 3;
pub const MAD_EMPHASIS_50_15_US: crate::stdlib::mad_emphasis = 1;
pub const MAD_EMPHASIS_NONE: crate::stdlib::mad_emphasis = 0;
pub const MAD_MODE_STEREO: crate::stdlib::mad_mode = 3;
pub const MAD_MODE_JOINT_STEREO: crate::stdlib::mad_mode = 2;
pub const MAD_MODE_DUAL_CHANNEL: crate::stdlib::mad_mode = 1;
pub const MAD_MODE_SINGLE_CHANNEL: crate::stdlib::mad_mode = 0;
pub const MAD_LAYER_III: crate::stdlib::mad_layer = 3;
pub const MAD_LAYER_II: crate::stdlib::mad_layer = 2;
pub const MAD_LAYER_I: crate::stdlib::mad_layer = 1;
// ================ END mad_h ================
// =============== BEGIN mixer_h ================
pub type snd_mixer_t = crate::stdlib::_snd_mixer;
pub type snd_mixer_class_t = crate::stdlib::_snd_mixer_class;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct snd_mixer_selem_regopt {
    pub ver: libc::c_int,
    pub abstract_0: crate::stdlib::snd_mixer_selem_regopt_abstract,
    pub device: *const libc::c_char,
    pub playback_pcm: *mut crate::stdlib::snd_pcm_t,
    pub capture_pcm: *mut crate::stdlib::snd_pcm_t,
}
pub type snd_mixer_selem_regopt_abstract = libc::c_uint;
pub type snd_mixer_elem_t = crate::stdlib::_snd_mixer_elem;
pub type snd_mixer_selem_id_t = crate::stdlib::_snd_mixer_selem_id;
pub type snd_mixer_selem_channel_id_t = crate::stdlib::_snd_mixer_selem_channel_id;
pub type _snd_mixer_selem_channel_id = libc::c_int;
pub const SND_MIXER_SABSTRACT_BASIC: crate::stdlib::snd_mixer_selem_regopt_abstract = 1;
pub const SND_MIXER_SABSTRACT_NONE: crate::stdlib::snd_mixer_selem_regopt_abstract = 0;
pub const SND_MIXER_SCHN_MONO: crate::stdlib::_snd_mixer_selem_channel_id = 0;
pub const SND_MIXER_SCHN_LAST: crate::stdlib::_snd_mixer_selem_channel_id = 31;
pub const SND_MIXER_SCHN_REAR_CENTER: crate::stdlib::_snd_mixer_selem_channel_id = 8;
pub const SND_MIXER_SCHN_SIDE_RIGHT: crate::stdlib::_snd_mixer_selem_channel_id = 7;
pub const SND_MIXER_SCHN_SIDE_LEFT: crate::stdlib::_snd_mixer_selem_channel_id = 6;
pub const SND_MIXER_SCHN_WOOFER: crate::stdlib::_snd_mixer_selem_channel_id = 5;
pub const SND_MIXER_SCHN_FRONT_CENTER: crate::stdlib::_snd_mixer_selem_channel_id = 4;
pub const SND_MIXER_SCHN_REAR_RIGHT: crate::stdlib::_snd_mixer_selem_channel_id = 3;
pub const SND_MIXER_SCHN_REAR_LEFT: crate::stdlib::_snd_mixer_selem_channel_id = 2;
pub const SND_MIXER_SCHN_FRONT_RIGHT: crate::stdlib::_snd_mixer_selem_channel_id = 1;
pub const SND_MIXER_SCHN_FRONT_LEFT: crate::stdlib::_snd_mixer_selem_channel_id = 0;
pub const SND_MIXER_SCHN_UNKNOWN: crate::stdlib::_snd_mixer_selem_channel_id = -1;
// ================ END mixer_h ================
// =============== BEGIN mpg123_h ================
pub type mpg123_handle = crate::stdlib::mpg123_handle_struct;
pub type mpg123_feature_set = libc::c_uint;
pub type mpg123_errors = libc::c_int;
pub const MPG123_ERR: crate::stdlib::mpg123_errors = -1;
pub const MPG123_DONE: crate::stdlib::mpg123_errors = -12;
pub const MPG123_FEATURE_EQUALIZER: crate::stdlib::mpg123_feature_set = 14;
pub const MPG123_FEATURE_TIMEOUT_READ: crate::stdlib::mpg123_feature_set = 13;
pub const MPG123_FEATURE_PARSE_ICY: crate::stdlib::mpg123_feature_set = 12;
pub const MPG123_FEATURE_DECODE_NTOM: crate::stdlib::mpg123_feature_set = 11;
pub const MPG123_FEATURE_DECODE_DOWNSAMPLE: crate::stdlib::mpg123_feature_set = 10;
pub const MPG123_FEATURE_DECODE_ACCURATE: crate::stdlib::mpg123_feature_set = 9;
pub const MPG123_FEATURE_DECODE_LAYER3: crate::stdlib::mpg123_feature_set = 8;
pub const MPG123_FEATURE_DECODE_LAYER2: crate::stdlib::mpg123_feature_set = 7;
pub const MPG123_FEATURE_DECODE_LAYER1: crate::stdlib::mpg123_feature_set = 6;
pub const MPG123_FEATURE_PARSE_ID3V2: crate::stdlib::mpg123_feature_set = 5;
pub const MPG123_FEATURE_INDEX: crate::stdlib::mpg123_feature_set = 4;
pub const MPG123_FEATURE_OUTPUT_32BIT: crate::stdlib::mpg123_feature_set = 3;
pub const MPG123_FEATURE_OUTPUT_16BIT: crate::stdlib::mpg123_feature_set = 2;
pub const MPG123_FEATURE_OUTPUT_8BIT: crate::stdlib::mpg123_feature_set = 1;
pub const MPG123_FEATURE_ABI_UTF8OPEN: crate::stdlib::mpg123_feature_set = 0;
pub const MPG123_NEW_FORMAT: crate::stdlib::mpg123_errors = -11;
pub const MPG123_INT_OVERFLOW: crate::stdlib::mpg123_errors = 43;
pub const MPG123_LFS_OVERFLOW: crate::stdlib::mpg123_errors = 42;
pub const MPG123_BAD_CUSTOM_IO: crate::stdlib::mpg123_errors = 41;
pub const MPG123_LSEEK_FAILED: crate::stdlib::mpg123_errors = 40;
pub const MPG123_BAD_VALUE: crate::stdlib::mpg123_errors = 39;
pub const MPG123_MISSING_FEATURE: crate::stdlib::mpg123_errors = 38;
pub const MPG123_BAD_DECODER_SETUP: crate::stdlib::mpg123_errors = 37;
pub const MPG123_INDEX_FAIL: crate::stdlib::mpg123_errors = 36;
pub const MPG123_NO_INDEX: crate::stdlib::mpg123_errors = 35;
pub const MPG123_BAD_KEY: crate::stdlib::mpg123_errors = 34;
pub const MPG123_NULL_POINTER: crate::stdlib::mpg123_errors = 33;
pub const MPG123_NO_RELSEEK: crate::stdlib::mpg123_errors = 32;
pub const MPG123_NULL_BUFFER: crate::stdlib::mpg123_errors = 31;
pub const MPG123_BAD_ALIGN: crate::stdlib::mpg123_errors = 30;
pub const MPG123_NO_8BIT: crate::stdlib::mpg123_errors = 29;
pub const MPG123_RESYNC_FAIL: crate::stdlib::mpg123_errors = 28;
pub const MPG123_OUT_OF_SYNC: crate::stdlib::mpg123_errors = 27;
pub const MPG123_BAD_INDEX_PAR: crate::stdlib::mpg123_errors = 26;
pub const MPG123_BAD_PARS: crate::stdlib::mpg123_errors = 25;
pub const MPG123_NO_READER: crate::stdlib::mpg123_errors = 24;
pub const MPG123_NO_SEEK: crate::stdlib::mpg123_errors = 23;
pub const MPG123_BAD_FILE: crate::stdlib::mpg123_errors = 22;
pub const MPG123_NO_TIMEOUT: crate::stdlib::mpg123_errors = 21;
pub const MPG123_BAD_WHENCE: crate::stdlib::mpg123_errors = 20;
pub const MPG123_NO_SEEK_FROM_END: crate::stdlib::mpg123_errors = 19;
pub const MPG123_ERR_READER: crate::stdlib::mpg123_errors = 18;
pub const MPG123_ERR_NULL: crate::stdlib::mpg123_errors = 17;
pub const MPG123_BAD_BAND: crate::stdlib::mpg123_errors = 16;
pub const MPG123_BAD_TYPES: crate::stdlib::mpg123_errors = 15;
pub const MPG123_NO_SPACE: crate::stdlib::mpg123_errors = 14;
pub const MPG123_NO_GAPLESS: crate::stdlib::mpg123_errors = 13;
pub const MPG123_BAD_RVA: crate::stdlib::mpg123_errors = 12;
pub const MPG123_NO_BUFFERS: crate::stdlib::mpg123_errors = 11;
pub const MPG123_BAD_HANDLE: crate::stdlib::mpg123_errors = 10;
pub const MPG123_BAD_DECODER: crate::stdlib::mpg123_errors = 9;
pub const MPG123_NOT_INITIALIZED: crate::stdlib::mpg123_errors = 8;
pub const MPG123_OUT_OF_MEM: crate::stdlib::mpg123_errors = 7;
pub const MPG123_BAD_BUFFER: crate::stdlib::mpg123_errors = 6;
pub const MPG123_BAD_PARAM: crate::stdlib::mpg123_errors = 5;
pub const MPG123_ERR_16TO8TABLE: crate::stdlib::mpg123_errors = 4;
pub const MPG123_BAD_RATE: crate::stdlib::mpg123_errors = 3;
pub const MPG123_BAD_CHANNEL: crate::stdlib::mpg123_errors = 2;
pub const MPG123_BAD_OUTFORMAT: crate::stdlib::mpg123_errors = 1;
pub const MPG123_OK: crate::stdlib::mpg123_errors = 0;
pub const MPG123_NEED_MORE: crate::stdlib::mpg123_errors = -10;
// ================ END mpg123_h ================
// =============== BEGIN neaacdec_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct NeAACDecFrameInfo {
    pub bytesconsumed: libc::c_ulong,
    pub samples: libc::c_ulong,
    pub channels: libc::c_uchar,
    pub error: libc::c_uchar,
    pub samplerate: libc::c_ulong,
    pub sbr: libc::c_uchar,
    pub object_type: libc::c_uchar,
    pub header_type: libc::c_uchar,
    pub num_front_channels: libc::c_uchar,
    pub num_side_channels: libc::c_uchar,
    pub num_back_channels: libc::c_uchar,
    pub num_lfe_channels: libc::c_uchar,
    pub channel_position: [libc::c_uchar; 64],
    pub ps: libc::c_uchar,
}
pub type NeAACDecHandle = *mut libc::c_void;
pub type NeAACDecConfigurationPtr = *mut crate::stdlib::NeAACDecConfiguration;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct NeAACDecConfiguration {
    pub defObjectType: libc::c_uchar,
    pub defSampleRate: libc::c_ulong,
    pub outputFormat: libc::c_uchar,
    pub downMatrix: libc::c_uchar,
    pub useOldADTSFormat: libc::c_uchar,
    pub dontUpSampleImplicitSBR: libc::c_uchar,
}
// ================ END neaacdec_h ================
// =============== BEGIN netdb_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct addrinfo {
    pub ai_flags: libc::c_int,
    pub ai_family: libc::c_int,
    pub ai_socktype: libc::c_int,
    pub ai_protocol: libc::c_int,
    pub ai_addrlen: crate::stdlib::socklen_t,
    pub ai_addr: *mut crate::stdlib::sockaddr,
    pub ai_canonname: *mut libc::c_char,
    pub ai_next: *mut crate::stdlib::addrinfo,
}
// ================ END netdb_h ================
// =============== BEGIN ogg_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ogg_sync_state {
    pub data: *mut libc::c_uchar,
    pub storage: libc::c_int,
    pub fill: libc::c_int,
    pub returned: libc::c_int,
    pub unsynced: libc::c_int,
    pub headerbytes: libc::c_int,
    pub bodybytes: libc::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ogg_stream_state {
    pub body_data: *mut libc::c_uchar,
    pub body_storage: libc::c_long,
    pub body_fill: libc::c_long,
    pub body_returned: libc::c_long,
    pub lacing_vals: *mut libc::c_int,
    pub granule_vals: *mut crate::stdlib::ogg_int64_t,
    pub lacing_storage: libc::c_long,
    pub lacing_fill: libc::c_long,
    pub lacing_packet: libc::c_long,
    pub lacing_returned: libc::c_long,
    pub header: [libc::c_uchar; 282],
    pub header_fill: libc::c_int,
    pub e_o_s: libc::c_int,
    pub b_o_s: libc::c_int,
    pub serialno: libc::c_long,
    pub pageno: libc::c_long,
    pub packetno: crate::stdlib::ogg_int64_t,
    pub granulepos: crate::stdlib::ogg_int64_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct oggpack_buffer {
    pub endbyte: libc::c_long,
    pub endbit: libc::c_int,
    pub buffer: *mut libc::c_uchar,
    pub ptr: *mut libc::c_uchar,
    pub storage: libc::c_long,
}
// ================ END ogg_h ================
// =============== BEGIN ordinals_h ================
pub type FLAC__int32 = crate::stdlib::int32_t;
pub type FLAC__bool = libc::c_int;
pub type FLAC__uint64 = crate::stdlib::uint64_t;
pub type FLAC__byte = crate::stdlib::FLAC__uint8;
pub type FLAC__uint8 = crate::stdlib::uint8_t;
pub type FLAC__uint32 = crate::stdlib::uint32_t;
pub type FLAC__uint16 = crate::stdlib::uint16_t;
// ================ END ordinals_h ================
// =============== BEGIN output_h ================
pub type snd_output_t = crate::stdlib::_snd_output;
// ================ END output_h ================
// =============== BEGIN pcm_h ================
pub type snd_pcm_t = crate::stdlib::_snd_pcm;
pub type snd_pcm_uframes_t = libc::c_ulong;
pub type snd_pcm_format_t = crate::stdlib::_snd_pcm_format;
pub type _snd_pcm_format = libc::c_int;
pub type snd_pcm_hw_params_t = crate::stdlib::_snd_pcm_hw_params;
pub type snd_pcm_stream_t = crate::stdlib::_snd_pcm_stream;
pub type _snd_pcm_stream = libc::c_uint;
pub type snd_pcm_sframes_t = libc::c_long;
pub type snd_pcm_state_t = crate::stdlib::_snd_pcm_state;
pub type _snd_pcm_state = libc::c_uint;
pub type snd_pcm_access_t = crate::stdlib::_snd_pcm_access;
pub type _snd_pcm_access = libc::c_uint;
pub type snd_pcm_channel_area_t = crate::stdlib::_snd_pcm_channel_area;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _snd_pcm_channel_area {
    pub addr: *mut libc::c_void,
    pub first: libc::c_uint,
    pub step: libc::c_uint,
}
pub const SND_PCM_FORMAT_U20: crate::stdlib::_snd_pcm_format = 27;
pub const SND_PCM_FORMAT_S20: crate::stdlib::_snd_pcm_format = 25;
pub const SND_PCM_FORMAT_IEC958_SUBFRAME: crate::stdlib::_snd_pcm_format = 18;
pub const SND_PCM_FORMAT_FLOAT64: crate::stdlib::_snd_pcm_format = 16;
pub const SND_PCM_FORMAT_FLOAT: crate::stdlib::_snd_pcm_format = 14;
pub const SND_PCM_FORMAT_U32: crate::stdlib::_snd_pcm_format = 12;
pub const SND_PCM_FORMAT_S32: crate::stdlib::_snd_pcm_format = 10;
pub const SND_PCM_FORMAT_U24: crate::stdlib::_snd_pcm_format = 8;
pub const SND_PCM_FORMAT_S24: crate::stdlib::_snd_pcm_format = 6;
pub const SND_PCM_FORMAT_U16: crate::stdlib::_snd_pcm_format = 4;
pub const SND_PCM_FORMAT_S16: crate::stdlib::_snd_pcm_format = 2;
pub const SND_PCM_FORMAT_LAST: crate::stdlib::_snd_pcm_format = 52;
pub const SND_PCM_FORMAT_DSD_U32_BE: crate::stdlib::_snd_pcm_format = 52;
pub const SND_PCM_FORMAT_DSD_U16_BE: crate::stdlib::_snd_pcm_format = 51;
pub const SND_PCM_FORMAT_DSD_U32_LE: crate::stdlib::_snd_pcm_format = 50;
pub const SND_PCM_FORMAT_DSD_U16_LE: crate::stdlib::_snd_pcm_format = 49;
pub const SND_PCM_FORMAT_DSD_U8: crate::stdlib::_snd_pcm_format = 48;
pub const SND_PCM_FORMAT_G723_40_1B: crate::stdlib::_snd_pcm_format = 47;
pub const SND_PCM_FORMAT_G723_40: crate::stdlib::_snd_pcm_format = 46;
pub const SND_PCM_FORMAT_G723_24_1B: crate::stdlib::_snd_pcm_format = 45;
pub const SND_PCM_FORMAT_G723_24: crate::stdlib::_snd_pcm_format = 44;
pub const SND_PCM_FORMAT_U18_3BE: crate::stdlib::_snd_pcm_format = 43;
pub const SND_PCM_FORMAT_U18_3LE: crate::stdlib::_snd_pcm_format = 42;
pub const SND_PCM_FORMAT_S18_3BE: crate::stdlib::_snd_pcm_format = 41;
pub const SND_PCM_FORMAT_S18_3LE: crate::stdlib::_snd_pcm_format = 40;
pub const SND_PCM_FORMAT_U20_3BE: crate::stdlib::_snd_pcm_format = 39;
pub const SND_PCM_FORMAT_U20_3LE: crate::stdlib::_snd_pcm_format = 38;
pub const SND_PCM_FORMAT_S20_3BE: crate::stdlib::_snd_pcm_format = 37;
pub const SND_PCM_FORMAT_S20_3LE: crate::stdlib::_snd_pcm_format = 36;
pub const SND_PCM_FORMAT_U24_3BE: crate::stdlib::_snd_pcm_format = 35;
pub const SND_PCM_FORMAT_U24_3LE: crate::stdlib::_snd_pcm_format = 34;
pub const SND_PCM_FORMAT_S24_3BE: crate::stdlib::_snd_pcm_format = 33;
pub const SND_PCM_FORMAT_S24_3LE: crate::stdlib::_snd_pcm_format = 32;
pub const SND_PCM_FORMAT_SPECIAL: crate::stdlib::_snd_pcm_format = 31;
pub const SND_PCM_FORMAT_U20_BE: crate::stdlib::_snd_pcm_format = 28;
pub const SND_PCM_FORMAT_U20_LE: crate::stdlib::_snd_pcm_format = 27;
pub const SND_PCM_FORMAT_S20_BE: crate::stdlib::_snd_pcm_format = 26;
pub const SND_PCM_FORMAT_S20_LE: crate::stdlib::_snd_pcm_format = 25;
pub const SND_PCM_FORMAT_GSM: crate::stdlib::_snd_pcm_format = 24;
pub const SND_PCM_FORMAT_MPEG: crate::stdlib::_snd_pcm_format = 23;
pub const SND_PCM_FORMAT_IMA_ADPCM: crate::stdlib::_snd_pcm_format = 22;
pub const SND_PCM_FORMAT_A_LAW: crate::stdlib::_snd_pcm_format = 21;
pub const SND_PCM_FORMAT_MU_LAW: crate::stdlib::_snd_pcm_format = 20;
pub const SND_PCM_FORMAT_IEC958_SUBFRAME_BE: crate::stdlib::_snd_pcm_format = 19;
pub const SND_PCM_FORMAT_IEC958_SUBFRAME_LE: crate::stdlib::_snd_pcm_format = 18;
pub const SND_PCM_FORMAT_FLOAT64_BE: crate::stdlib::_snd_pcm_format = 17;
pub const SND_PCM_FORMAT_FLOAT64_LE: crate::stdlib::_snd_pcm_format = 16;
pub const SND_PCM_FORMAT_FLOAT_BE: crate::stdlib::_snd_pcm_format = 15;
pub const SND_PCM_FORMAT_FLOAT_LE: crate::stdlib::_snd_pcm_format = 14;
pub const SND_PCM_FORMAT_U32_BE: crate::stdlib::_snd_pcm_format = 13;
pub const SND_PCM_FORMAT_U32_LE: crate::stdlib::_snd_pcm_format = 12;
pub const SND_PCM_FORMAT_S32_BE: crate::stdlib::_snd_pcm_format = 11;
pub const SND_PCM_FORMAT_S32_LE: crate::stdlib::_snd_pcm_format = 10;
pub const SND_PCM_FORMAT_U24_BE: crate::stdlib::_snd_pcm_format = 9;
pub const SND_PCM_FORMAT_U24_LE: crate::stdlib::_snd_pcm_format = 8;
pub const SND_PCM_FORMAT_S24_BE: crate::stdlib::_snd_pcm_format = 7;
pub const SND_PCM_FORMAT_S24_LE: crate::stdlib::_snd_pcm_format = 6;
pub const SND_PCM_FORMAT_U16_BE: crate::stdlib::_snd_pcm_format = 5;
pub const SND_PCM_FORMAT_U16_LE: crate::stdlib::_snd_pcm_format = 4;
pub const SND_PCM_FORMAT_S16_BE: crate::stdlib::_snd_pcm_format = 3;
pub const SND_PCM_FORMAT_S16_LE: crate::stdlib::_snd_pcm_format = 2;
pub const SND_PCM_FORMAT_U8: crate::stdlib::_snd_pcm_format = 1;
pub const SND_PCM_FORMAT_S8: crate::stdlib::_snd_pcm_format = 0;
pub const SND_PCM_FORMAT_UNKNOWN: crate::stdlib::_snd_pcm_format = -1;
pub const SND_PCM_STREAM_LAST: crate::stdlib::_snd_pcm_stream = 1;
pub const SND_PCM_STREAM_CAPTURE: crate::stdlib::_snd_pcm_stream = 1;
pub const SND_PCM_STREAM_PLAYBACK: crate::stdlib::_snd_pcm_stream = 0;
pub const SND_PCM_STATE_DISCONNECTED: crate::stdlib::_snd_pcm_state = 8;
pub const SND_PCM_STATE_PRIVATE1: crate::stdlib::_snd_pcm_state = 1024;
pub const SND_PCM_STATE_LAST: crate::stdlib::_snd_pcm_state = 8;
pub const SND_PCM_STATE_SUSPENDED: crate::stdlib::_snd_pcm_state = 7;
pub const SND_PCM_STATE_PAUSED: crate::stdlib::_snd_pcm_state = 6;
pub const SND_PCM_STATE_DRAINING: crate::stdlib::_snd_pcm_state = 5;
pub const SND_PCM_STATE_XRUN: crate::stdlib::_snd_pcm_state = 4;
pub const SND_PCM_STATE_RUNNING: crate::stdlib::_snd_pcm_state = 3;
pub const SND_PCM_STATE_PREPARED: crate::stdlib::_snd_pcm_state = 2;
pub const SND_PCM_STATE_SETUP: crate::stdlib::_snd_pcm_state = 1;
pub const SND_PCM_STATE_OPEN: crate::stdlib::_snd_pcm_state = 0;
pub const SND_PCM_ACCESS_LAST: crate::stdlib::_snd_pcm_access = 4;
pub const SND_PCM_ACCESS_RW_NONINTERLEAVED: crate::stdlib::_snd_pcm_access = 4;
pub const SND_PCM_ACCESS_RW_INTERLEAVED: crate::stdlib::_snd_pcm_access = 3;
pub const SND_PCM_ACCESS_MMAP_COMPLEX: crate::stdlib::_snd_pcm_access = 2;
pub const SND_PCM_ACCESS_MMAP_NONINTERLEAVED: crate::stdlib::_snd_pcm_access = 1;
pub const SND_PCM_ACCESS_MMAP_INTERLEAVED: crate::stdlib::_snd_pcm_access = 0;
// ================ END pcm_h ================
// =============== BEGIN poll_h ================
pub type nfds_t = libc::c_ulong;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct pollfd {
    pub fd: libc::c_int,
    pub events: libc::c_short,
    pub revents: libc::c_short,
}
// ================ END poll_h ================
// =============== BEGIN pthread_h ================
pub type C2RustUnnamed_0 = libc::c_uint;
pub const PTHREAD_PRIO_PROTECT: crate::stdlib::C2RustUnnamed_0 = 2;
pub const PTHREAD_PRIO_INHERIT: crate::stdlib::C2RustUnnamed_0 = 1;
pub const PTHREAD_PRIO_NONE: crate::stdlib::C2RustUnnamed_0 = 0;
// ================ END pthread_h ================
// =============== BEGIN pthreadtypes_h ================
pub type pthread_t = libc::c_ulong;
#[repr(C)]
#[derive(Copy, Clone)]
pub union pthread_attr_t {
    pub __size: [libc::c_char; 56],
    pub __align: libc::c_long,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union pthread_mutexattr_t {
    pub __size: [libc::c_char; 4],
    pub __align: libc::c_int,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union pthread_mutex_t {
    pub __data: crate::stdlib::__pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
// ================ END pthreadtypes_h ================
// =============== BEGIN select_h ================
pub type __fd_mask = libc::c_long;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct fd_set {
    pub __fds_bits: [crate::stdlib::__fd_mask; 16],
}
// ================ END select_h ================
// =============== BEGIN sockaddr_h ================
pub type sa_family_t = libc::c_ushort;
// ================ END sockaddr_h ================
// =============== BEGIN socket_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sockaddr {
    pub sa_family: crate::stdlib::sa_family_t,
    pub sa_data: [libc::c_char; 14],
}
pub const MSG_CMSG_CLOEXEC: crate::stdlib::C2RustUnnamed_0 = 1073741824;
pub const MSG_FASTOPEN: crate::stdlib::C2RustUnnamed_0 = 536870912;
pub const MSG_ZEROCOPY: crate::stdlib::C2RustUnnamed_0 = 67108864;
pub const MSG_BATCH: crate::stdlib::C2RustUnnamed_0 = 262144;
pub const MSG_WAITFORONE: crate::stdlib::C2RustUnnamed_0 = 65536;
pub const MSG_MORE: crate::stdlib::C2RustUnnamed_0 = 32768;
pub const MSG_NOSIGNAL: crate::stdlib::C2RustUnnamed_0 = 16384;
pub const MSG_ERRQUEUE: crate::stdlib::C2RustUnnamed_0 = 8192;
pub const MSG_RST: crate::stdlib::C2RustUnnamed_0 = 4096;
pub const MSG_CONFIRM: crate::stdlib::C2RustUnnamed_0 = 2048;
pub const MSG_SYN: crate::stdlib::C2RustUnnamed_0 = 1024;
pub const MSG_FIN: crate::stdlib::C2RustUnnamed_0 = 512;
pub const MSG_WAITALL: crate::stdlib::C2RustUnnamed_0 = 256;
pub const MSG_EOR: crate::stdlib::C2RustUnnamed_0 = 128;
pub const MSG_DONTWAIT: crate::stdlib::C2RustUnnamed_0 = 64;
pub const MSG_TRUNC: crate::stdlib::C2RustUnnamed_0 = 32;
pub const MSG_PROXY: crate::stdlib::C2RustUnnamed_0 = 16;
pub const MSG_CTRUNC: crate::stdlib::C2RustUnnamed_0 = 8;
pub const MSG_DONTROUTE: crate::stdlib::C2RustUnnamed_0 = 4;
pub const MSG_PEEK: crate::stdlib::C2RustUnnamed_0 = 2;
pub const MSG_OOB: crate::stdlib::C2RustUnnamed_0 = 1;
pub const MSG_TRYHARD: crate::stdlib::C2RustUnnamed_0 = 4;
// ================ END socket_h ================
// =============== BEGIN socket_type_h ================
pub type __socket_type = libc::c_uint;
pub const SOCK_NONBLOCK: crate::stdlib::__socket_type = 2048;
pub const SOCK_CLOEXEC: crate::stdlib::__socket_type = 524288;
pub const SOCK_PACKET: crate::stdlib::__socket_type = 10;
pub const SOCK_DCCP: crate::stdlib::__socket_type = 6;
pub const SOCK_SEQPACKET: crate::stdlib::__socket_type = 5;
pub const SOCK_RDM: crate::stdlib::__socket_type = 4;
pub const SOCK_RAW: crate::stdlib::__socket_type = 3;
pub const SOCK_DGRAM: crate::stdlib::__socket_type = 2;
pub const SOCK_STREAM: crate::stdlib::__socket_type = 1;
// ================ END socket_type_h ================
// =============== BEGIN stdint_h ================
pub type uintptr_t = libc::c_ulong;
// ================ END stdint_h ================
// =============== BEGIN stdint_intn_h ================
pub type int16_t = crate::stdlib::__int16_t;
pub type int32_t = crate::stdlib::__int32_t;
pub type int64_t = crate::stdlib::__int64_t;
// ================ END stdint_intn_h ================
// =============== BEGIN stdint_uintn_h ================
pub type uint8_t = crate::stdlib::__uint8_t;
pub type uint16_t = crate::stdlib::__uint16_t;
pub type uint32_t = crate::stdlib::__uint32_t;
pub type uint64_t = crate::stdlib::__uint64_t;
// ================ END stdint_uintn_h ================
// =============== BEGIN stdio_h ================
pub type ssize_t = crate::stdlib::__ssize_t;
// ================ END stdio_h ================
// =============== BEGIN stream_decoder_h ================
pub type FLAC__StreamDecoderState = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FLAC__StreamDecoder {
    pub protected_: *mut crate::stdlib::FLAC__StreamDecoderProtected,
    pub private_: *mut crate::stdlib::FLAC__StreamDecoderPrivate,
}
pub type FLAC__StreamDecoderErrorCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: crate::stdlib::FLAC__StreamDecoderErrorStatus,
        _: *mut libc::c_void,
    ) -> (),
>;
pub type FLAC__StreamDecoderErrorStatus = libc::c_uint;
pub type FLAC__StreamDecoderMetadataCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: *const crate::stdlib::FLAC__StreamMetadata,
        _: *mut libc::c_void,
    ) -> (),
>;
pub type FLAC__StreamDecoderWriteCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: *const crate::stdlib::FLAC__Frame,
        _: *const *const crate::stdlib::FLAC__int32,
        _: *mut libc::c_void,
    ) -> crate::stdlib::FLAC__StreamDecoderWriteStatus,
>;
pub type FLAC__StreamDecoderWriteStatus = libc::c_uint;
pub type FLAC__StreamDecoderEofCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: *mut libc::c_void,
    ) -> crate::stdlib::FLAC__bool,
>;
pub type FLAC__StreamDecoderLengthCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: *mut crate::stdlib::FLAC__uint64,
        _: *mut libc::c_void,
    ) -> crate::stdlib::FLAC__StreamDecoderLengthStatus,
>;
pub type FLAC__StreamDecoderLengthStatus = libc::c_uint;
pub type FLAC__StreamDecoderTellCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: *mut crate::stdlib::FLAC__uint64,
        _: *mut libc::c_void,
    ) -> crate::stdlib::FLAC__StreamDecoderTellStatus,
>;
pub type FLAC__StreamDecoderTellStatus = libc::c_uint;
pub type FLAC__StreamDecoderSeekCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: crate::stdlib::FLAC__uint64,
        _: *mut libc::c_void,
    ) -> crate::stdlib::FLAC__StreamDecoderSeekStatus,
>;
pub type FLAC__StreamDecoderSeekStatus = libc::c_uint;
pub type FLAC__StreamDecoderReadCallback = Option<
    unsafe extern "C" fn(
        _: *const crate::stdlib::FLAC__StreamDecoder,
        _: *mut crate::stdlib::FLAC__byte,
        _: *mut crate::stddef_h::size_t,
        _: *mut libc::c_void,
    ) -> crate::stdlib::FLAC__StreamDecoderReadStatus,
>;
pub type FLAC__StreamDecoderReadStatus = libc::c_uint;
pub type FLAC__StreamDecoderInitStatus = libc::c_uint;
pub const FLAC__STREAM_DECODER_END_OF_STREAM: crate::stdlib::FLAC__StreamDecoderState = 4;
pub const FLAC__STREAM_DECODER_UNINITIALIZED: crate::stdlib::FLAC__StreamDecoderState = 9;
pub const FLAC__STREAM_DECODER_MEMORY_ALLOCATION_ERROR: crate::stdlib::FLAC__StreamDecoderState = 8;
pub const FLAC__STREAM_DECODER_ABORTED: crate::stdlib::FLAC__StreamDecoderState = 7;
pub const FLAC__STREAM_DECODER_SEEK_ERROR: crate::stdlib::FLAC__StreamDecoderState = 6;
pub const FLAC__STREAM_DECODER_OGG_ERROR: crate::stdlib::FLAC__StreamDecoderState = 5;
pub const FLAC__STREAM_DECODER_READ_FRAME: crate::stdlib::FLAC__StreamDecoderState = 3;
pub const FLAC__STREAM_DECODER_SEARCH_FOR_FRAME_SYNC: crate::stdlib::FLAC__StreamDecoderState = 2;
pub const FLAC__STREAM_DECODER_READ_METADATA: crate::stdlib::FLAC__StreamDecoderState = 1;
pub const FLAC__STREAM_DECODER_SEARCH_FOR_METADATA: crate::stdlib::FLAC__StreamDecoderState = 0;
pub const FLAC__STREAM_DECODER_ERROR_STATUS_UNPARSEABLE_STREAM:
    crate::stdlib::FLAC__StreamDecoderErrorStatus = 3;
pub const FLAC__STREAM_DECODER_ERROR_STATUS_FRAME_CRC_MISMATCH:
    crate::stdlib::FLAC__StreamDecoderErrorStatus = 2;
pub const FLAC__STREAM_DECODER_ERROR_STATUS_BAD_HEADER:
    crate::stdlib::FLAC__StreamDecoderErrorStatus = 1;
pub const FLAC__STREAM_DECODER_ERROR_STATUS_LOST_SYNC:
    crate::stdlib::FLAC__StreamDecoderErrorStatus = 0;
pub const FLAC__STREAM_DECODER_WRITE_STATUS_ABORT: crate::stdlib::FLAC__StreamDecoderWriteStatus =
    1;
pub const FLAC__STREAM_DECODER_WRITE_STATUS_CONTINUE:
    crate::stdlib::FLAC__StreamDecoderWriteStatus = 0;
pub const FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED:
    crate::stdlib::FLAC__StreamDecoderLengthStatus = 2;
pub const FLAC__STREAM_DECODER_LENGTH_STATUS_ERROR: crate::stdlib::FLAC__StreamDecoderLengthStatus =
    1;
pub const FLAC__STREAM_DECODER_LENGTH_STATUS_OK: crate::stdlib::FLAC__StreamDecoderLengthStatus = 0;
pub const FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED:
    crate::stdlib::FLAC__StreamDecoderTellStatus = 2;
pub const FLAC__STREAM_DECODER_TELL_STATUS_ERROR: crate::stdlib::FLAC__StreamDecoderTellStatus = 1;
pub const FLAC__STREAM_DECODER_TELL_STATUS_OK: crate::stdlib::FLAC__StreamDecoderTellStatus = 0;
pub const FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED:
    crate::stdlib::FLAC__StreamDecoderSeekStatus = 2;
pub const FLAC__STREAM_DECODER_SEEK_STATUS_ERROR: crate::stdlib::FLAC__StreamDecoderSeekStatus = 1;
pub const FLAC__STREAM_DECODER_SEEK_STATUS_OK: crate::stdlib::FLAC__StreamDecoderSeekStatus = 0;
pub const FLAC__STREAM_DECODER_READ_STATUS_ABORT: crate::stdlib::FLAC__StreamDecoderReadStatus = 2;
pub const FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM:
    crate::stdlib::FLAC__StreamDecoderReadStatus = 1;
pub const FLAC__STREAM_DECODER_READ_STATUS_CONTINUE: crate::stdlib::FLAC__StreamDecoderReadStatus =
    0;
pub const FLAC__STREAM_DECODER_INIT_STATUS_ALREADY_INITIALIZED:
    crate::stdlib::FLAC__StreamDecoderInitStatus = 5;
pub const FLAC__STREAM_DECODER_INIT_STATUS_ERROR_OPENING_FILE:
    crate::stdlib::FLAC__StreamDecoderInitStatus = 4;
pub const FLAC__STREAM_DECODER_INIT_STATUS_MEMORY_ALLOCATION_ERROR:
    crate::stdlib::FLAC__StreamDecoderInitStatus = 3;
pub const FLAC__STREAM_DECODER_INIT_STATUS_INVALID_CALLBACKS:
    crate::stdlib::FLAC__StreamDecoderInitStatus = 2;
pub const FLAC__STREAM_DECODER_INIT_STATUS_UNSUPPORTED_CONTAINER:
    crate::stdlib::FLAC__StreamDecoderInitStatus = 1;
pub const FLAC__STREAM_DECODER_INIT_STATUS_OK: crate::stdlib::FLAC__StreamDecoderInitStatus = 0;
// ================ END stream_decoder_h ================
// =============== BEGIN struct_FILE_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IO_FILE {
    pub _flags: libc::c_int,
    pub _IO_read_ptr: *mut libc::c_char,
    pub _IO_read_end: *mut libc::c_char,
    pub _IO_read_base: *mut libc::c_char,
    pub _IO_write_base: *mut libc::c_char,
    pub _IO_write_ptr: *mut libc::c_char,
    pub _IO_write_end: *mut libc::c_char,
    pub _IO_buf_base: *mut libc::c_char,
    pub _IO_buf_end: *mut libc::c_char,
    pub _IO_save_base: *mut libc::c_char,
    pub _IO_backup_base: *mut libc::c_char,
    pub _IO_save_end: *mut libc::c_char,
    pub _markers: *mut crate::stdlib::_IO_marker,
    pub _chain: *mut crate::stdlib::_IO_FILE,
    pub _fileno: libc::c_int,
    pub _flags2: libc::c_int,
    pub _old_offset: crate::stdlib::__off_t,
    pub _cur_column: libc::c_ushort,
    pub _vtable_offset: libc::c_schar,
    pub _shortbuf: [libc::c_char; 1],
    pub _lock: *mut libc::c_void,
    pub _offset: crate::stdlib::__off64_t,
    pub _codecvt: *mut crate::stdlib::_IO_codecvt,
    pub _wide_data: *mut crate::stdlib::_IO_wide_data,
    pub _freeres_list: *mut crate::stdlib::_IO_FILE,
    pub _freeres_buf: *mut libc::c_void,
    pub __pad5: crate::stddef_h::size_t,
    pub _mode: libc::c_int,
    pub _unused2: [libc::c_char; 20],
}
pub type _IO_lock_t = ();
// ================ END struct_FILE_h ================
// =============== BEGIN struct_sched_param_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sched_param {
    pub sched_priority: libc::c_int,
}
// ================ END struct_sched_param_h ================
// =============== BEGIN struct_timespec_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timespec {
    pub tv_sec: crate::stdlib::__time_t,
    pub tv_nsec: crate::stdlib::__syscall_slong_t,
}
// ================ END struct_timespec_h ================
// =============== BEGIN struct_timeval_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timeval {
    pub tv_sec: crate::stdlib::__time_t,
    pub tv_usec: crate::stdlib::__suseconds_t,
}
// ================ END struct_timeval_h ================
// =============== BEGIN struct_tm_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tm {
    pub tm_sec: libc::c_int,
    pub tm_min: libc::c_int,
    pub tm_hour: libc::c_int,
    pub tm_mday: libc::c_int,
    pub tm_mon: libc::c_int,
    pub tm_year: libc::c_int,
    pub tm_wday: libc::c_int,
    pub tm_yday: libc::c_int,
    pub tm_isdst: libc::c_int,
    pub tm_gmtoff: libc::c_long,
    pub tm_zone: *const libc::c_char,
}
// ================ END struct_tm_h ================
// =============== BEGIN sys_types_h ================
pub type u_int32_t = crate::stdlib::__uint32_t;
pub type u_int64_t = crate::stdlib::__uint64_t;
pub type u_int16_t = crate::stdlib::__uint16_t;
pub type u_int8_t = crate::stdlib::__uint8_t;
// ================ END sys_types_h ================
// =============== BEGIN thread_shared_types_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __pthread_internal_list {
    pub __prev: *mut crate::stdlib::__pthread_internal_list,
    pub __next: *mut crate::stdlib::__pthread_internal_list,
}
pub type __pthread_list_t = crate::stdlib::__pthread_internal_list;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: crate::stdlib::__pthread_list_t,
}
// ================ END thread_shared_types_h ================
// =============== BEGIN time_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct timezone {
    pub tz_minuteswest: libc::c_int,
    pub tz_dsttime: libc::c_int,
}
pub type __timezone_ptr_t = *mut crate::stdlib::timezone;
// ================ END time_h ================
// =============== BEGIN time_t_h ================
pub type time_t = crate::stdlib::__time_t;
// ================ END time_t_h ================
// =============== BEGIN types_h ================
pub type __uint16_t = libc::c_ushort;
pub type __int16_t = libc::c_short;
pub type __time_t = libc::c_long;
pub type __suseconds_t = libc::c_long;
pub type __clockid_t = libc::c_int;
pub type __syscall_slong_t = libc::c_long;
pub type __caddr_t = *mut libc::c_char;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type __useconds_t = libc::c_uint;
pub type __int64_t = libc::c_long;
pub type __ssize_t = libc::c_long;
pub type __socklen_t = libc::c_uint;
pub type __uint8_t = libc::c_uchar;
pub type __off_t = libc::c_long;
pub type __off64_t = libc::c_long;
// ================ END types_h ================
// =============== BEGIN unistd_h ================
pub type socklen_t = crate::stdlib::__socklen_t;
// ================ END unistd_h ================
// =============== BEGIN vorbisfile_h ================
#[repr(C)]
#[derive(Copy, Clone)]
pub struct OggVorbis_File {
    pub datasource: *mut libc::c_void,
    pub seekable: libc::c_int,
    pub offset: crate::stdlib::ogg_int64_t,
    pub end: crate::stdlib::ogg_int64_t,
    pub oy: crate::stdlib::ogg_sync_state,
    pub links: libc::c_int,
    pub offsets: *mut crate::stdlib::ogg_int64_t,
    pub dataoffsets: *mut crate::stdlib::ogg_int64_t,
    pub serialnos: *mut libc::c_long,
    pub pcmlengths: *mut crate::stdlib::ogg_int64_t,
    pub vi: *mut crate::stdlib::vorbis_info,
    pub vc: *mut crate::stdlib::vorbis_comment,
    pub pcm_offset: crate::stdlib::ogg_int64_t,
    pub ready_state: libc::c_int,
    pub current_serialno: libc::c_long,
    pub current_link: libc::c_int,
    pub bittrack: libc::c_double,
    pub samptrack: libc::c_double,
    pub os: crate::stdlib::ogg_stream_state,
    pub vd: crate::stdlib::vorbis_dsp_state,
    pub vb: crate::stdlib::vorbis_block,
    pub callbacks: crate::stdlib::ov_callbacks,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ov_callbacks {
    pub read_func: Option<
        unsafe extern "C" fn(
            _: *mut libc::c_void,
            _: crate::stddef_h::size_t,
            _: crate::stddef_h::size_t,
            _: *mut libc::c_void,
        ) -> crate::stddef_h::size_t,
    >,
    pub seek_func: Option<
        unsafe extern "C" fn(
            _: *mut libc::c_void,
            _: crate::stdlib::ogg_int64_t,
            _: libc::c_int,
        ) -> libc::c_int,
    >,
    pub close_func: Option<unsafe extern "C" fn(_: *mut libc::c_void) -> libc::c_int>,
    pub tell_func: Option<unsafe extern "C" fn(_: *mut libc::c_void) -> libc::c_long>,
}
