use ::libc;

pub use crate::stddef_h::size_t;

pub use crate::stdlib::__int16_t;
pub use crate::stdlib::__int32_t;
pub use crate::stdlib::__pthread_internal_list;
pub use crate::stdlib::__pthread_list_t;
pub use crate::stdlib::__pthread_mutex_s;
pub use crate::stdlib::__uint32_t;
pub use crate::stdlib::__uint64_t;
pub use crate::stdlib::__uint8_t;
pub use crate::stdlib::int16_t;
pub use crate::stdlib::int32_t;
pub use crate::stdlib::pthread_mutex_t;
pub use crate::stdlib::u_int32_t;
pub use crate::stdlib::u_int64_t;
pub use crate::stdlib::u_int8_t;

pub use crate::squeezelite_h::buffer;
pub use crate::squeezelite_h::codec;
pub use crate::squeezelite_h::decode_state;
pub use crate::squeezelite_h::decodestate;
pub use crate::squeezelite_h::disconnect_code;
pub use crate::squeezelite_h::fade_dir;
pub use crate::squeezelite_h::fade_mode;
pub use crate::squeezelite_h::fade_state;
pub use crate::squeezelite_h::frames_t;
pub use crate::squeezelite_h::lDEBUG;
pub use crate::squeezelite_h::lERROR;
pub use crate::squeezelite_h::lINFO;
pub use crate::squeezelite_h::lSDEBUG;
pub use crate::squeezelite_h::lWARN;
pub use crate::squeezelite_h::log_level;
pub use crate::squeezelite_h::output_format;
pub use crate::squeezelite_h::output_state;
pub use crate::squeezelite_h::outputstate;
pub use crate::squeezelite_h::s16_t;
pub use crate::squeezelite_h::s32_t;
pub use crate::squeezelite_h::stream_state;
pub use crate::squeezelite_h::streamstate;
pub use crate::squeezelite_h::u32_t;
pub use crate::squeezelite_h::u64_t;
pub use crate::squeezelite_h::u8_t;
pub use crate::squeezelite_h::C2RustUnnamed_1;
pub use crate::squeezelite_h::_buf_used;
pub use crate::squeezelite_h::DECODE_COMPLETE;
pub use crate::squeezelite_h::DECODE_ERROR;
pub use crate::squeezelite_h::DECODE_READY;
pub use crate::squeezelite_h::DECODE_RUNNING;
pub use crate::squeezelite_h::DECODE_STOPPED;
pub use crate::squeezelite_h::DISCONNECT;
pub use crate::squeezelite_h::DISCONNECT_OK;
pub use crate::squeezelite_h::FADE_ACTIVE;
pub use crate::squeezelite_h::FADE_CROSS;
pub use crate::squeezelite_h::FADE_CROSSFADE;
pub use crate::squeezelite_h::FADE_DOWN;
pub use crate::squeezelite_h::FADE_DUE;
pub use crate::squeezelite_h::FADE_IN;
pub use crate::squeezelite_h::FADE_INACTIVE;
pub use crate::squeezelite_h::FADE_INOUT;
pub use crate::squeezelite_h::FADE_NONE;
pub use crate::squeezelite_h::FADE_OUT;
pub use crate::squeezelite_h::FADE_UP;
pub use crate::squeezelite_h::LOCAL_DISCONNECT;
pub use crate::squeezelite_h::OUTPUT_BUFFER;
pub use crate::squeezelite_h::OUTPUT_OFF;
pub use crate::squeezelite_h::OUTPUT_PAUSE_FRAMES;
pub use crate::squeezelite_h::OUTPUT_RUNNING;
pub use crate::squeezelite_h::OUTPUT_SKIP_FRAMES;
pub use crate::squeezelite_h::OUTPUT_START_AT;
pub use crate::squeezelite_h::OUTPUT_STOPPED;
pub use crate::squeezelite_h::RECV_HEADERS;
pub use crate::squeezelite_h::REMOTE_DISCONNECT;
pub use crate::squeezelite_h::S16_LE;
pub use crate::squeezelite_h::S24_3LE;
pub use crate::squeezelite_h::S24_LE;
pub use crate::squeezelite_h::S32_LE;
pub use crate::squeezelite_h::SEND_HEADERS;
pub use crate::squeezelite_h::STOPPED;
pub use crate::squeezelite_h::STREAMING_BUFFERING;
pub use crate::squeezelite_h::STREAMING_FILE;
pub use crate::squeezelite_h::STREAMING_HTTP;
pub use crate::squeezelite_h::STREAMING_WAIT;
pub use crate::squeezelite_h::TIMEOUT;
pub use crate::squeezelite_h::UNREACHABLE;
pub use crate::src::buffer::_buf_cont_read;
pub use crate::src::buffer::_buf_cont_write;
pub use crate::src::buffer::_buf_inc_readp;
pub use crate::src::buffer::_buf_inc_writep;
pub use crate::src::buffer::_buf_space;
pub use crate::src::decode::decode_newstream;
pub use crate::src::output::_checkfade;
pub use crate::src::utils::logprint;
pub use crate::src::utils::logtime;
use crate::stdlib::malloc;
pub use crate::stdlib::mpg123_enc_enum;
pub use crate::stdlib::mpg123_errors;
pub use crate::stdlib::mpg123_feature_set;
pub use crate::stdlib::mpg123_handle;
pub use crate::stdlib::mpg123_handle_struct;
pub use crate::stdlib::MPG123_BAD_ALIGN;
pub use crate::stdlib::MPG123_BAD_BAND;
pub use crate::stdlib::MPG123_BAD_BUFFER;
pub use crate::stdlib::MPG123_BAD_CHANNEL;
pub use crate::stdlib::MPG123_BAD_CUSTOM_IO;
pub use crate::stdlib::MPG123_BAD_DECODER;
pub use crate::stdlib::MPG123_BAD_DECODER_SETUP;
pub use crate::stdlib::MPG123_BAD_FILE;
pub use crate::stdlib::MPG123_BAD_HANDLE;
pub use crate::stdlib::MPG123_BAD_INDEX_PAR;
pub use crate::stdlib::MPG123_BAD_KEY;
pub use crate::stdlib::MPG123_BAD_OUTFORMAT;
pub use crate::stdlib::MPG123_BAD_PARAM;
pub use crate::stdlib::MPG123_BAD_PARS;
pub use crate::stdlib::MPG123_BAD_RATE;
pub use crate::stdlib::MPG123_BAD_RVA;
pub use crate::stdlib::MPG123_BAD_TYPES;
pub use crate::stdlib::MPG123_BAD_VALUE;
pub use crate::stdlib::MPG123_BAD_WHENCE;
pub use crate::stdlib::MPG123_DONE;
pub use crate::stdlib::MPG123_ENC_16;
pub use crate::stdlib::MPG123_ENC_24;
pub use crate::stdlib::MPG123_ENC_32;
pub use crate::stdlib::MPG123_ENC_8;
pub use crate::stdlib::MPG123_ENC_ALAW_8;
pub use crate::stdlib::MPG123_ENC_ANY;
pub use crate::stdlib::MPG123_ENC_FLOAT;
pub use crate::stdlib::MPG123_ENC_FLOAT_32;
pub use crate::stdlib::MPG123_ENC_FLOAT_64;
pub use crate::stdlib::MPG123_ENC_SIGNED;
pub use crate::stdlib::MPG123_ENC_SIGNED_16;
pub use crate::stdlib::MPG123_ENC_SIGNED_24;
pub use crate::stdlib::MPG123_ENC_SIGNED_32;
pub use crate::stdlib::MPG123_ENC_SIGNED_8;
pub use crate::stdlib::MPG123_ENC_ULAW_8;
pub use crate::stdlib::MPG123_ENC_UNSIGNED_16;
pub use crate::stdlib::MPG123_ENC_UNSIGNED_24;
pub use crate::stdlib::MPG123_ENC_UNSIGNED_32;
pub use crate::stdlib::MPG123_ENC_UNSIGNED_8;
pub use crate::stdlib::MPG123_ERR;
pub use crate::stdlib::MPG123_ERR_16TO8TABLE;
pub use crate::stdlib::MPG123_ERR_NULL;
pub use crate::stdlib::MPG123_ERR_READER;
pub use crate::stdlib::MPG123_FEATURE_ABI_UTF8OPEN;
pub use crate::stdlib::MPG123_FEATURE_DECODE_ACCURATE;
pub use crate::stdlib::MPG123_FEATURE_DECODE_DOWNSAMPLE;
pub use crate::stdlib::MPG123_FEATURE_DECODE_LAYER1;
pub use crate::stdlib::MPG123_FEATURE_DECODE_LAYER2;
pub use crate::stdlib::MPG123_FEATURE_DECODE_LAYER3;
pub use crate::stdlib::MPG123_FEATURE_DECODE_NTOM;
pub use crate::stdlib::MPG123_FEATURE_EQUALIZER;
pub use crate::stdlib::MPG123_FEATURE_INDEX;
pub use crate::stdlib::MPG123_FEATURE_OUTPUT_16BIT;
pub use crate::stdlib::MPG123_FEATURE_OUTPUT_32BIT;
pub use crate::stdlib::MPG123_FEATURE_OUTPUT_8BIT;
pub use crate::stdlib::MPG123_FEATURE_PARSE_ICY;
pub use crate::stdlib::MPG123_FEATURE_PARSE_ID3V2;
pub use crate::stdlib::MPG123_FEATURE_TIMEOUT_READ;
pub use crate::stdlib::MPG123_INDEX_FAIL;
pub use crate::stdlib::MPG123_INT_OVERFLOW;
pub use crate::stdlib::MPG123_LFS_OVERFLOW;
pub use crate::stdlib::MPG123_LSEEK_FAILED;
pub use crate::stdlib::MPG123_MISSING_FEATURE;
pub use crate::stdlib::MPG123_NEED_MORE;
pub use crate::stdlib::MPG123_NEW_FORMAT;
pub use crate::stdlib::MPG123_NOT_INITIALIZED;
pub use crate::stdlib::MPG123_NO_8BIT;
pub use crate::stdlib::MPG123_NO_BUFFERS;
pub use crate::stdlib::MPG123_NO_GAPLESS;
pub use crate::stdlib::MPG123_NO_INDEX;
pub use crate::stdlib::MPG123_NO_READER;
pub use crate::stdlib::MPG123_NO_RELSEEK;
pub use crate::stdlib::MPG123_NO_SEEK;
pub use crate::stdlib::MPG123_NO_SEEK_FROM_END;
pub use crate::stdlib::MPG123_NO_SPACE;
pub use crate::stdlib::MPG123_NO_TIMEOUT;
pub use crate::stdlib::MPG123_NULL_BUFFER;
pub use crate::stdlib::MPG123_NULL_POINTER;
pub use crate::stdlib::MPG123_OK;
pub use crate::stdlib::MPG123_OUT_OF_MEM;
pub use crate::stdlib::MPG123_OUT_OF_SYNC;
pub use crate::stdlib::MPG123_RESYNC_FAIL;

use crate::stdlib::dlerror;
use crate::stdlib::dlopen;
use crate::stdlib::dlsym;
use crate::stdlib::pthread_mutex_lock;
use crate::stdlib::pthread_mutex_unlock;
extern "C" {
    #[no_mangle]
    pub static mut loglevel: crate::squeezelite_h::log_level;
    #[no_mangle]
    pub static mut streambuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut outputbuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut stream: crate::squeezelite_h::streamstate;
    #[no_mangle]
    pub static mut output: crate::squeezelite_h::outputstate;
    #[no_mangle]
    pub static mut decode: crate::squeezelite_h::decodestate;
}

#[repr(C)]
#[derive(Copy, Clone)]
pub struct mpg {
    pub h: *mut crate::stdlib::mpg123_handle,
    pub use16bit: bool,
    pub mpg123_init: Option<unsafe extern "C" fn() -> libc::c_int>,
    pub mpg123_feature:
        Option<unsafe extern "C" fn(_: crate::stdlib::mpg123_feature_set) -> libc::c_int>,
    pub mpg123_rates: Option<
        unsafe extern "C" fn(_: *mut *const libc::c_long, _: *mut crate::stddef_h::size_t) -> (),
    >,
    pub mpg123_format_none:
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mpg123_handle) -> libc::c_int>,
    pub mpg123_format: Option<
        unsafe extern "C" fn(
            _: *mut crate::stdlib::mpg123_handle,
            _: libc::c_long,
            _: libc::c_int,
            _: libc::c_int,
        ) -> libc::c_int,
    >,
    pub mpg123_new: Option<
        unsafe extern "C" fn(
            _: *const libc::c_char,
            _: *mut libc::c_int,
        ) -> *mut crate::stdlib::mpg123_handle,
    >,
    pub mpg123_delete: Option<unsafe extern "C" fn(_: *mut crate::stdlib::mpg123_handle) -> ()>,
    pub mpg123_open_feed:
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mpg123_handle) -> libc::c_int>,
    pub mpg123_decode: Option<
        unsafe extern "C" fn(
            _: *mut crate::stdlib::mpg123_handle,
            _: *const libc::c_uchar,
            _: crate::stddef_h::size_t,
            _: *mut libc::c_uchar,
            _: crate::stddef_h::size_t,
            _: *mut crate::stddef_h::size_t,
        ) -> libc::c_int,
    >,
    pub mpg123_getformat: Option<
        unsafe extern "C" fn(
            _: *mut crate::stdlib::mpg123_handle,
            _: *mut libc::c_long,
            _: *mut libc::c_int,
            _: *mut libc::c_int,
        ) -> libc::c_int,
    >,
    pub mpg123_plain_strerror: Option<unsafe extern "C" fn(_: libc::c_int) -> *const libc::c_char>,
}

static mut m: *mut mpg = 0 as *const mpg as *mut mpg;

unsafe extern "C" fn mpg_decode() -> crate::squeezelite_h::decode_state {
    let mut bytes: crate::stddef_h::size_t = 0;
    let mut space: crate::stddef_h::size_t = 0;
    let mut size: crate::stddef_h::size_t = 0;
    let mut ret: libc::c_int = 0;
    let mut write_buf = 0 as *mut crate::squeezelite_h::u8_t;
    crate::stdlib::pthread_mutex_lock(&mut (*streambuf).mutex);
    crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
    bytes = if crate::squeezelite_h::_buf_used(streambuf)
        < crate::src::buffer::_buf_cont_read(streambuf)
    {
        crate::squeezelite_h::_buf_used(streambuf)
    } else {
        crate::src::buffer::_buf_cont_read(streambuf)
    } as crate::stddef_h::size_t;
    space = if crate::src::buffer::_buf_space(outputbuf)
        < crate::src::buffer::_buf_cont_write(outputbuf)
    {
        crate::src::buffer::_buf_space(outputbuf)
    } else {
        crate::src::buffer::_buf_cont_write(outputbuf)
    } as crate::stddef_h::size_t;
    write_buf = (*outputbuf).writep;
    bytes = if bytes < 512 as libc::c_int as libc::c_ulong {
        bytes
    } else {
        512 as libc::c_int as libc::c_ulong
    };
    space = if space < (32 as libc::c_int * 1024 as libc::c_int) as libc::c_ulong {
        space
    } else {
        (32 as libc::c_int * 1024 as libc::c_int) as libc::c_ulong
    };
    if (*m).use16bit {
        space = space
            .wrapping_div(8 as libc::c_int as libc::c_ulong)
            .wrapping_mul(4 as libc::c_int as libc::c_ulong)
    }
    // only get the new stream information on first call so we can reset decode.direct appropriately
    if decode.new_stream {
        space = 0 as libc::c_int as crate::stddef_h::size_t
    }
    ret = (*m).mpg123_decode.expect("non-null function pointer")(
        (*m).h,
        (*streambuf).readp,
        bytes,
        write_buf,
        space,
        &mut size,
    );
    if ret == crate::stdlib::MPG123_NEW_FORMAT as libc::c_int {
        if decode.new_stream {
            let mut rate: libc::c_long = 0;
            let mut channels: libc::c_int = 0;
            let mut enc: libc::c_int = 0;
            (*m).mpg123_getformat.expect("non-null function pointer")(
                (*m).h,
                &mut rate,
                &mut channels,
                &mut enc,
            );
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d setting track_start\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mpg_decode\x00"))
                        .as_ptr(),
                    125 as libc::c_int,
                );
            }
            output.next_sample_rate = crate::src::decode::decode_newstream(
                rate as libc::c_uint,
                output.supported_rates.as_mut_ptr(),
            );
            output.track_start = (*outputbuf).writep;
            if output.fade_mode as u64 != 0 {
                crate::src::output::_checkfade(1 as libc::c_int != 0);
            }
            decode.new_stream = 0 as libc::c_int != 0
        } else if loglevel as libc::c_uint
            >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
        {
            crate::src::utils::logprint(
                b"%s %s:%d format change mid stream - not supported\n\x00" as *const u8
                    as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mpg_decode\x00"))
                    .as_ptr(),
                135 as libc::c_int,
            );
        }
    }
    // expand 16bit output to 32bit samples
    if (*m).use16bit {
        let mut iptr = 0 as *mut crate::squeezelite_h::s16_t;
        let mut optr = 0 as *mut crate::squeezelite_h::s32_t;
        let mut count = size.wrapping_div(2 as libc::c_int as libc::c_ulong);
        size = count.wrapping_mul(4 as libc::c_int as libc::c_ulong);
        iptr = (write_buf as *mut crate::squeezelite_h::s16_t).offset(count as isize);
        optr = (write_buf as *mut crate::squeezelite_h::s32_t).offset(count as isize);
        loop {
            let fresh0 = count;
            count = count.wrapping_sub(1);
            if !(fresh0 != 0) {
                break;
            }
            iptr = iptr.offset(-1);
            optr = optr.offset(-1);
            *optr = (*iptr as libc::c_int) << 16 as libc::c_int
        }
    }
    crate::src::buffer::_buf_inc_readp(streambuf, bytes as libc::c_uint);
    crate::src::buffer::_buf_inc_writep(outputbuf, size as libc::c_uint);
    crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
    if loglevel as libc::c_uint >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d write %u frames\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mpg_decode\x00")).as_ptr(),
            163 as libc::c_int,
            size.wrapping_div(8 as libc::c_int as libc::c_ulong),
        );
    }
    if ret == crate::stdlib::MPG123_DONE as libc::c_int
        || bytes == 0 as libc::c_int as libc::c_ulong
            && size == 0 as libc::c_int as libc::c_ulong
            && stream.state as libc::c_uint
                <= crate::squeezelite_h::DISCONNECT as libc::c_int as libc::c_uint
    {
        crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d stream complete\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mpg_decode\x00"))
                    .as_ptr(),
                167 as libc::c_int,
            );
        }
        return crate::squeezelite_h::DECODE_COMPLETE;
    }
    crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
    if ret == crate::stdlib::MPG123_ERR as libc::c_int {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d Error\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"mpg_decode\x00"))
                    .as_ptr(),
                174 as libc::c_int,
            );
        }
        return crate::squeezelite_h::DECODE_COMPLETE;
    }
    // OK and NEED_MORE keep running
    return crate::squeezelite_h::DECODE_RUNNING;
}

unsafe extern "C" fn mpg_open(
    mut size: crate::squeezelite_h::u8_t,
    mut rate: crate::squeezelite_h::u8_t,
    mut chan: crate::squeezelite_h::u8_t,
    mut endianness: crate::squeezelite_h::u8_t,
) {
    let mut err: libc::c_int = 0;
    let mut list = 0 as *const libc::c_long;
    let mut count: crate::stddef_h::size_t = 0;
    let mut i: crate::stddef_h::size_t = 0;
    if !(*m).h.is_null() {
        (*m).mpg123_delete.expect("non-null function pointer")((*m).h);
    }
    (*m).h =
        (*m).mpg123_new.expect("non-null function pointer")(0 as *const libc::c_char, &mut err);
    if (*m).h.is_null() {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d new error: %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"mpg_open\x00")).as_ptr(),
                194 as libc::c_int,
                (*m).mpg123_plain_strerror
                    .expect("non-null function pointer")(err),
            );
        }
    }
    // restrict output to 32bit or 16bit signed 2 channel based on library capability
    (*m).mpg123_rates.expect("non-null function pointer")(&mut list, &mut count);
    (*m).mpg123_format_none.expect("non-null function pointer")((*m).h);
    i = 0 as libc::c_int as crate::stddef_h::size_t;
    while i < count {
        (*m).mpg123_format.expect("non-null function pointer")(
            (*m).h,
            *list.offset(i as isize),
            2 as libc::c_int,
            if (*m).use16bit as libc::c_int != 0 {
                crate::stdlib::MPG123_ENC_SIGNED_16 as libc::c_int
            } else {
                crate::stdlib::MPG123_ENC_SIGNED_32 as libc::c_int
            },
        );
        i = i.wrapping_add(1)
    }
    err = (*m).mpg123_open_feed.expect("non-null function pointer")((*m).h);
    if err != 0 {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d open feed error: %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"mpg_open\x00")).as_ptr(),
                207 as libc::c_int,
                (*m).mpg123_plain_strerror
                    .expect("non-null function pointer")(err),
            );
        }
    };
}

unsafe extern "C" fn mpg_close() {
    (*m).mpg123_delete.expect("non-null function pointer")((*m).h);
    (*m).h = 0 as *mut crate::stdlib::mpg123_handle;
}

unsafe extern "C" fn load_mpg() -> bool {
    let mut handle = crate::stdlib::dlopen(
        b"libmpg123.so.0\x00" as *const u8 as *const libc::c_char,
        0x2 as libc::c_int,
    );
    let mut err = 0 as *mut libc::c_char;
    if handle.is_null() {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d dlerror: %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"load_mpg\x00")).as_ptr(),
                222 as libc::c_int,
                crate::stdlib::dlerror(),
            );
        }
        return 0 as libc::c_int != 0;
    }
    (*m).mpg123_init = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn() -> libc::c_int>,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_init\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_feature = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: crate::stdlib::mpg123_feature_set) -> libc::c_int>,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_feature\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_rates = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *mut *const libc::c_long,
                _: *mut crate::stddef_h::size_t,
            ) -> (),
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_rates\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_format_none = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mpg123_handle) -> libc::c_int>,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_format_none\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_format = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *mut crate::stdlib::mpg123_handle,
                _: libc::c_long,
                _: libc::c_int,
                _: libc::c_int,
            ) -> libc::c_int,
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_format\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_new = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *const libc::c_char,
                _: *mut libc::c_int,
            ) -> *mut crate::stdlib::mpg123_handle,
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_new\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_delete = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mpg123_handle) -> ()>,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_delete\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_open_feed = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: *mut crate::stdlib::mpg123_handle) -> libc::c_int>,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_open_feed\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_decode = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *mut crate::stdlib::mpg123_handle,
                _: *const libc::c_uchar,
                _: crate::stddef_h::size_t,
                _: *mut libc::c_uchar,
                _: crate::stddef_h::size_t,
                _: *mut crate::stddef_h::size_t,
            ) -> libc::c_int,
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_decode\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_getformat = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<
            unsafe extern "C" fn(
                _: *mut crate::stdlib::mpg123_handle,
                _: *mut libc::c_long,
                _: *mut libc::c_int,
                _: *mut libc::c_int,
            ) -> libc::c_int,
        >,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_getformat\x00" as *const u8 as *const libc::c_char,
    ));
    (*m).mpg123_plain_strerror = ::std::mem::transmute::<
        *mut libc::c_void,
        Option<unsafe extern "C" fn(_: libc::c_int) -> *const libc::c_char>,
    >(crate::stdlib::dlsym(
        handle,
        b"mpg123_plain_strerror\x00" as *const u8 as *const libc::c_char,
    ));
    err = crate::stdlib::dlerror();
    if !err.is_null() {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d dlerror: %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"load_mpg\x00")).as_ptr(),
                239 as libc::c_int,
                err,
            );
        }
        return 0 as libc::c_int != 0;
    }
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d loaded libmpg123.so.0\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"load_mpg\x00")).as_ptr(),
            243 as libc::c_int,
        );
    }
    return 1 as libc::c_int != 0;
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
// output_pack.c
// output_vis.c
// dop.c
// codecs
#[no_mangle]

pub unsafe extern "C" fn register_mpg() -> *mut crate::squeezelite_h::codec {
    static mut ret: crate::squeezelite_h::codec = unsafe {
        {
            let mut init = crate::squeezelite_h::codec {
                id: 'm' as i32 as libc::c_char,
                types: b"mp3\x00" as *const u8 as *const libc::c_char as *mut libc::c_char,
                min_read_bytes: 512 as libc::c_int as libc::c_uint,
                min_space: (32 as libc::c_int * 1024 as libc::c_int) as libc::c_uint,
                open: Some(
                    mpg_open
                        as unsafe extern "C" fn(
                            _: crate::squeezelite_h::u8_t,
                            _: crate::squeezelite_h::u8_t,
                            _: crate::squeezelite_h::u8_t,
                            _: crate::squeezelite_h::u8_t,
                        ) -> (),
                ),
                close: Some(mpg_close as unsafe extern "C" fn() -> ()),
                decode: Some(
                    mpg_decode as unsafe extern "C" fn() -> crate::squeezelite_h::decode_state,
                ),
            };
            init
        }
    };
    m = crate::stdlib::malloc(::std::mem::size_of::<mpg>() as libc::c_ulong) as *mut mpg;
    if m.is_null() {
        return 0 as *mut crate::squeezelite_h::codec;
    }
    (*m).h = 0 as *mut crate::stdlib::mpg123_handle;
    if !load_mpg() {
        return 0 as *mut crate::squeezelite_h::codec;
    }
    (*m).mpg123_init.expect("non-null function pointer")();
    (*m).use16bit = (*m).mpg123_feature.expect("non-null function pointer")(
        crate::stdlib::MPG123_FEATURE_OUTPUT_32BIT,
    ) != 0;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d using mpg to decode mp3\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"register_mpg\x00"))
                .as_ptr(),
            275 as libc::c_int,
        );
    }
    return &mut ret;
}
