use ::c2rust_asm_casts;
use ::libc;

pub use crate::internal::__builtin_va_list;
pub use crate::internal::__va_list_tag;
pub use crate::stdarg_h::va_list;
pub use crate::stddef_h::size_t;
use c2rust_asm_casts::AsmCastTrait;

pub use crate::stdlib::_IO_codecvt;
pub use crate::stdlib::_IO_lock_t;
pub use crate::stdlib::_IO_marker;
pub use crate::stdlib::_IO_wide_data;
pub use crate::stdlib::__caddr_t;
pub use crate::stdlib::__clockid_t;
pub use crate::stdlib::__off64_t;
pub use crate::stdlib::__off_t;
pub use crate::stdlib::__socklen_t;
pub use crate::stdlib::__suseconds_t;
pub use crate::stdlib::__syscall_slong_t;
pub use crate::stdlib::__time_t;
pub use crate::stdlib::__uint16_t;
pub use crate::stdlib::__uint32_t;
pub use crate::stdlib::__uint64_t;
pub use crate::stdlib::__uint8_t;
pub use crate::stdlib::clockid_t;
pub use crate::stdlib::time_t;
pub use crate::stdlib::timespec;
pub use crate::stdlib::timeval;
pub use crate::stdlib::u_int16_t;
pub use crate::stdlib::u_int32_t;
pub use crate::stdlib::u_int8_t;
pub use crate::stdlib::FILE;
pub use crate::stdlib::_IO_FILE;

pub use crate::stdlib::__fd_mask;
pub use crate::stdlib::__socket_type;
pub use crate::stdlib::close;
pub use crate::stdlib::fd_set;
pub use crate::stdlib::sa_family_t;
pub use crate::stdlib::select;
pub use crate::stdlib::sockaddr;
pub use crate::stdlib::socklen_t;
pub use crate::stdlib::sysconf;
pub use crate::stdlib::uint16_t;
pub use crate::stdlib::uint32_t;
pub use crate::stdlib::uint64_t;
pub use crate::stdlib::C2RustUnnamed_0;
pub use crate::stdlib::SOCK_CLOEXEC;
pub use crate::stdlib::SOCK_DCCP;
pub use crate::stdlib::SOCK_DGRAM;
pub use crate::stdlib::SOCK_NONBLOCK;
pub use crate::stdlib::SOCK_PACKET;
pub use crate::stdlib::SOCK_RAW;
pub use crate::stdlib::SOCK_RDM;
pub use crate::stdlib::SOCK_SEQPACKET;
pub use crate::stdlib::SOCK_STREAM;
pub use crate::stdlib::_SC_2_CHAR_TERM;
pub use crate::stdlib::_SC_2_C_BIND;
pub use crate::stdlib::_SC_2_C_DEV;
pub use crate::stdlib::_SC_2_C_VERSION;
pub use crate::stdlib::_SC_2_FORT_DEV;
pub use crate::stdlib::_SC_2_FORT_RUN;
pub use crate::stdlib::_SC_2_LOCALEDEF;
pub use crate::stdlib::_SC_2_PBS;
pub use crate::stdlib::_SC_2_PBS_ACCOUNTING;
pub use crate::stdlib::_SC_2_PBS_CHECKPOINT;
pub use crate::stdlib::_SC_2_PBS_LOCATE;
pub use crate::stdlib::_SC_2_PBS_MESSAGE;
pub use crate::stdlib::_SC_2_PBS_TRACK;
pub use crate::stdlib::_SC_2_SW_DEV;
pub use crate::stdlib::_SC_2_UPE;
pub use crate::stdlib::_SC_2_VERSION;
pub use crate::stdlib::_SC_ADVISORY_INFO;
pub use crate::stdlib::_SC_AIO_LISTIO_MAX;
pub use crate::stdlib::_SC_AIO_MAX;
pub use crate::stdlib::_SC_AIO_PRIO_DELTA_MAX;
pub use crate::stdlib::_SC_ARG_MAX;
pub use crate::stdlib::_SC_ASYNCHRONOUS_IO;
pub use crate::stdlib::_SC_ATEXIT_MAX;
pub use crate::stdlib::_SC_AVPHYS_PAGES;
pub use crate::stdlib::_SC_BARRIERS;
pub use crate::stdlib::_SC_BASE;
pub use crate::stdlib::_SC_BC_BASE_MAX;
pub use crate::stdlib::_SC_BC_DIM_MAX;
pub use crate::stdlib::_SC_BC_SCALE_MAX;
pub use crate::stdlib::_SC_BC_STRING_MAX;
pub use crate::stdlib::_SC_CHARCLASS_NAME_MAX;
pub use crate::stdlib::_SC_CHAR_BIT;
pub use crate::stdlib::_SC_CHAR_MAX;
pub use crate::stdlib::_SC_CHAR_MIN;
pub use crate::stdlib::_SC_CHILD_MAX;
pub use crate::stdlib::_SC_CLK_TCK;
pub use crate::stdlib::_SC_CLOCK_SELECTION;
pub use crate::stdlib::_SC_COLL_WEIGHTS_MAX;
pub use crate::stdlib::_SC_CPUTIME;
pub use crate::stdlib::_SC_C_LANG_SUPPORT;
pub use crate::stdlib::_SC_C_LANG_SUPPORT_R;
pub use crate::stdlib::_SC_DELAYTIMER_MAX;
pub use crate::stdlib::_SC_DEVICE_IO;
pub use crate::stdlib::_SC_DEVICE_SPECIFIC;
pub use crate::stdlib::_SC_DEVICE_SPECIFIC_R;
pub use crate::stdlib::_SC_EQUIV_CLASS_MAX;
pub use crate::stdlib::_SC_EXPR_NEST_MAX;
pub use crate::stdlib::_SC_FD_MGMT;
pub use crate::stdlib::_SC_FIFO;
pub use crate::stdlib::_SC_FILE_ATTRIBUTES;
pub use crate::stdlib::_SC_FILE_LOCKING;
pub use crate::stdlib::_SC_FILE_SYSTEM;
pub use crate::stdlib::_SC_FSYNC;
pub use crate::stdlib::_SC_GETGR_R_SIZE_MAX;
pub use crate::stdlib::_SC_GETPW_R_SIZE_MAX;
pub use crate::stdlib::_SC_HOST_NAME_MAX;
pub use crate::stdlib::_SC_INT_MAX;
pub use crate::stdlib::_SC_INT_MIN;
pub use crate::stdlib::_SC_IOV_MAX;
pub use crate::stdlib::_SC_IPV6;
pub use crate::stdlib::_SC_JOB_CONTROL;
pub use crate::stdlib::_SC_LEVEL1_DCACHE_ASSOC;
pub use crate::stdlib::_SC_LEVEL1_DCACHE_LINESIZE;
pub use crate::stdlib::_SC_LEVEL1_DCACHE_SIZE;
pub use crate::stdlib::_SC_LEVEL1_ICACHE_ASSOC;
pub use crate::stdlib::_SC_LEVEL1_ICACHE_LINESIZE;
pub use crate::stdlib::_SC_LEVEL1_ICACHE_SIZE;
pub use crate::stdlib::_SC_LEVEL2_CACHE_ASSOC;
pub use crate::stdlib::_SC_LEVEL2_CACHE_LINESIZE;
pub use crate::stdlib::_SC_LEVEL2_CACHE_SIZE;
pub use crate::stdlib::_SC_LEVEL3_CACHE_ASSOC;
pub use crate::stdlib::_SC_LEVEL3_CACHE_LINESIZE;
pub use crate::stdlib::_SC_LEVEL3_CACHE_SIZE;
pub use crate::stdlib::_SC_LEVEL4_CACHE_ASSOC;
pub use crate::stdlib::_SC_LEVEL4_CACHE_LINESIZE;
pub use crate::stdlib::_SC_LEVEL4_CACHE_SIZE;
pub use crate::stdlib::_SC_LINE_MAX;
pub use crate::stdlib::_SC_LOGIN_NAME_MAX;
pub use crate::stdlib::_SC_LONG_BIT;
pub use crate::stdlib::_SC_MAPPED_FILES;
pub use crate::stdlib::_SC_MB_LEN_MAX;
pub use crate::stdlib::_SC_MEMLOCK;
pub use crate::stdlib::_SC_MEMLOCK_RANGE;
pub use crate::stdlib::_SC_MEMORY_PROTECTION;
pub use crate::stdlib::_SC_MESSAGE_PASSING;
pub use crate::stdlib::_SC_MONOTONIC_CLOCK;
pub use crate::stdlib::_SC_MQ_OPEN_MAX;
pub use crate::stdlib::_SC_MQ_PRIO_MAX;
pub use crate::stdlib::_SC_MULTI_PROCESS;
pub use crate::stdlib::_SC_NETWORKING;
pub use crate::stdlib::_SC_NGROUPS_MAX;
pub use crate::stdlib::_SC_NL_ARGMAX;
pub use crate::stdlib::_SC_NL_LANGMAX;
pub use crate::stdlib::_SC_NL_MSGMAX;
pub use crate::stdlib::_SC_NL_NMAX;
pub use crate::stdlib::_SC_NL_SETMAX;
pub use crate::stdlib::_SC_NL_TEXTMAX;
pub use crate::stdlib::_SC_NPROCESSORS_CONF;
pub use crate::stdlib::_SC_NPROCESSORS_ONLN;
pub use crate::stdlib::_SC_NZERO;
pub use crate::stdlib::_SC_OPEN_MAX;
pub use crate::stdlib::_SC_PAGESIZE;
pub use crate::stdlib::_SC_PASS_MAX;
pub use crate::stdlib::_SC_PHYS_PAGES;
pub use crate::stdlib::_SC_PII;
pub use crate::stdlib::_SC_PII_INTERNET;
pub use crate::stdlib::_SC_PII_INTERNET_DGRAM;
pub use crate::stdlib::_SC_PII_INTERNET_STREAM;
pub use crate::stdlib::_SC_PII_OSI;
pub use crate::stdlib::_SC_PII_OSI_CLTS;
pub use crate::stdlib::_SC_PII_OSI_COTS;
pub use crate::stdlib::_SC_PII_OSI_M;
pub use crate::stdlib::_SC_PII_SOCKET;
pub use crate::stdlib::_SC_PII_XTI;
pub use crate::stdlib::_SC_PIPE;
pub use crate::stdlib::_SC_POLL;
pub use crate::stdlib::_SC_PRIORITIZED_IO;
pub use crate::stdlib::_SC_PRIORITY_SCHEDULING;
pub use crate::stdlib::_SC_RAW_SOCKETS;
pub use crate::stdlib::_SC_READER_WRITER_LOCKS;
pub use crate::stdlib::_SC_REALTIME_SIGNALS;
pub use crate::stdlib::_SC_REGEXP;
pub use crate::stdlib::_SC_REGEX_VERSION;
pub use crate::stdlib::_SC_RE_DUP_MAX;
pub use crate::stdlib::_SC_RTSIG_MAX;
pub use crate::stdlib::_SC_SAVED_IDS;
pub use crate::stdlib::_SC_SCHAR_MAX;
pub use crate::stdlib::_SC_SCHAR_MIN;
pub use crate::stdlib::_SC_SELECT;
pub use crate::stdlib::_SC_SEMAPHORES;
pub use crate::stdlib::_SC_SEM_NSEMS_MAX;
pub use crate::stdlib::_SC_SEM_VALUE_MAX;
pub use crate::stdlib::_SC_SHARED_MEMORY_OBJECTS;
pub use crate::stdlib::_SC_SHELL;
pub use crate::stdlib::_SC_SHRT_MAX;
pub use crate::stdlib::_SC_SHRT_MIN;
pub use crate::stdlib::_SC_SIGNALS;
pub use crate::stdlib::_SC_SIGQUEUE_MAX;
pub use crate::stdlib::_SC_SINGLE_PROCESS;
pub use crate::stdlib::_SC_SPAWN;
pub use crate::stdlib::_SC_SPIN_LOCKS;
pub use crate::stdlib::_SC_SPORADIC_SERVER;
pub use crate::stdlib::_SC_SSIZE_MAX;
pub use crate::stdlib::_SC_SS_REPL_MAX;
pub use crate::stdlib::_SC_STREAMS;
pub use crate::stdlib::_SC_STREAM_MAX;
pub use crate::stdlib::_SC_SYMLOOP_MAX;
pub use crate::stdlib::_SC_SYNCHRONIZED_IO;
pub use crate::stdlib::_SC_SYSTEM_DATABASE;
pub use crate::stdlib::_SC_SYSTEM_DATABASE_R;
pub use crate::stdlib::_SC_THREADS;
pub use crate::stdlib::_SC_THREAD_ATTR_STACKADDR;
pub use crate::stdlib::_SC_THREAD_ATTR_STACKSIZE;
pub use crate::stdlib::_SC_THREAD_CPUTIME;
pub use crate::stdlib::_SC_THREAD_DESTRUCTOR_ITERATIONS;
pub use crate::stdlib::_SC_THREAD_KEYS_MAX;
pub use crate::stdlib::_SC_THREAD_PRIORITY_SCHEDULING;
pub use crate::stdlib::_SC_THREAD_PRIO_INHERIT;
pub use crate::stdlib::_SC_THREAD_PRIO_PROTECT;
pub use crate::stdlib::_SC_THREAD_PROCESS_SHARED;
pub use crate::stdlib::_SC_THREAD_ROBUST_PRIO_INHERIT;
pub use crate::stdlib::_SC_THREAD_ROBUST_PRIO_PROTECT;
pub use crate::stdlib::_SC_THREAD_SAFE_FUNCTIONS;
pub use crate::stdlib::_SC_THREAD_SPORADIC_SERVER;
pub use crate::stdlib::_SC_THREAD_STACK_MIN;
pub use crate::stdlib::_SC_THREAD_THREADS_MAX;
pub use crate::stdlib::_SC_TIMEOUTS;
pub use crate::stdlib::_SC_TIMERS;
pub use crate::stdlib::_SC_TIMER_MAX;
pub use crate::stdlib::_SC_TRACE;
pub use crate::stdlib::_SC_TRACE_EVENT_FILTER;
pub use crate::stdlib::_SC_TRACE_EVENT_NAME_MAX;
pub use crate::stdlib::_SC_TRACE_INHERIT;
pub use crate::stdlib::_SC_TRACE_LOG;
pub use crate::stdlib::_SC_TRACE_NAME_MAX;
pub use crate::stdlib::_SC_TRACE_SYS_MAX;
pub use crate::stdlib::_SC_TRACE_USER_EVENT_MAX;
pub use crate::stdlib::_SC_TTY_NAME_MAX;
pub use crate::stdlib::_SC_TYPED_MEMORY_OBJECTS;
pub use crate::stdlib::_SC_TZNAME_MAX;
pub use crate::stdlib::_SC_T_IOV_MAX;
pub use crate::stdlib::_SC_UCHAR_MAX;
pub use crate::stdlib::_SC_UINT_MAX;
pub use crate::stdlib::_SC_UIO_MAXIOV;
pub use crate::stdlib::_SC_ULONG_MAX;
pub use crate::stdlib::_SC_USER_GROUPS;
pub use crate::stdlib::_SC_USER_GROUPS_R;
pub use crate::stdlib::_SC_USHRT_MAX;
pub use crate::stdlib::_SC_V6_ILP32_OFF32;
pub use crate::stdlib::_SC_V6_ILP32_OFFBIG;
pub use crate::stdlib::_SC_V6_LP64_OFF64;
pub use crate::stdlib::_SC_V6_LPBIG_OFFBIG;
pub use crate::stdlib::_SC_V7_ILP32_OFF32;
pub use crate::stdlib::_SC_V7_ILP32_OFFBIG;
pub use crate::stdlib::_SC_V7_LP64_OFF64;
pub use crate::stdlib::_SC_V7_LPBIG_OFFBIG;
pub use crate::stdlib::_SC_VERSION;
pub use crate::stdlib::_SC_WORD_BIT;
pub use crate::stdlib::_SC_XBS5_ILP32_OFF32;
pub use crate::stdlib::_SC_XBS5_ILP32_OFFBIG;
pub use crate::stdlib::_SC_XBS5_LP64_OFF64;
pub use crate::stdlib::_SC_XBS5_LPBIG_OFFBIG;
pub use crate::stdlib::_SC_XOPEN_CRYPT;
pub use crate::stdlib::_SC_XOPEN_ENH_I18N;
pub use crate::stdlib::_SC_XOPEN_LEGACY;
pub use crate::stdlib::_SC_XOPEN_REALTIME;
pub use crate::stdlib::_SC_XOPEN_REALTIME_THREADS;
pub use crate::stdlib::_SC_XOPEN_SHM;
pub use crate::stdlib::_SC_XOPEN_STREAMS;
pub use crate::stdlib::_SC_XOPEN_UNIX;
pub use crate::stdlib::_SC_XOPEN_VERSION;
pub use crate::stdlib::_SC_XOPEN_XCU_VERSION;
pub use crate::stdlib::_SC_XOPEN_XPG2;
pub use crate::stdlib::_SC_XOPEN_XPG3;
pub use crate::stdlib::_SC_XOPEN_XPG4;

pub use crate::stdlib::__timezone_ptr_t;
pub use crate::stdlib::gettimeofday;
pub use crate::stdlib::in_addr;
pub use crate::stdlib::in_addr_t;
pub use crate::stdlib::in_port_t;
pub use crate::stdlib::nfds_t;
pub use crate::stdlib::poll;
pub use crate::stdlib::pollfd;
pub use crate::stdlib::sockaddr_in;
pub use crate::stdlib::timezone;
pub use crate::stdlib::tm;

pub use crate::squeezelite_h::event_type;
pub use crate::squeezelite_h::sockfd;
pub use crate::squeezelite_h::u16_t;
pub use crate::squeezelite_h::u32_t;
pub use crate::squeezelite_h::u8_t;
pub use crate::squeezelite_h::EVENT_READ;
pub use crate::squeezelite_h::EVENT_TIMEOUT;
pub use crate::squeezelite_h::EVENT_WAKE;
use crate::stdlib::__errno_location;
pub use crate::stdlib::addrinfo;
use crate::stdlib::atoi;
pub use crate::stdlib::eventfd_read;
pub use crate::stdlib::eventfd_t;
use crate::stdlib::fflush;
pub use crate::stdlib::freeaddrinfo;
pub use crate::stdlib::getaddrinfo;
use crate::stdlib::getenv;
pub use crate::stdlib::ifconf;
pub use crate::stdlib::ifmap;
pub use crate::stdlib::ifreq;
use crate::stdlib::memcpy;
use crate::stdlib::memset;
use crate::stdlib::sprintf;
use crate::stdlib::sscanf;
use crate::stdlib::stderr;
use crate::stdlib::strchr;
use crate::stdlib::strlen;
use crate::stdlib::strncpy;
use crate::stdlib::strtok;
use crate::stdlib::vfprintf;
pub use crate::stdlib::C2RustUnnamed_20;
pub use crate::stdlib::C2RustUnnamed_21;
pub use crate::stdlib::C2RustUnnamed_22;

use crate::stdlib::clock_gettime;
use crate::stdlib::connect;
use crate::stdlib::fcntl;
use crate::stdlib::getsockopt;
use crate::stdlib::ioctl;
use crate::stdlib::localtime;
use crate::stdlib::socket;
use crate::stdlib::strftime;
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// logging functions
#[no_mangle]

pub unsafe extern "C" fn logtime() -> *const libc::c_char {
    static mut buf: [libc::c_char; 100] = [0; 100];
    let mut tv = crate::stdlib::timeval {
        tv_sec: 0,
        tv_usec: 0,
    };
    crate::stdlib::gettimeofday(&mut tv, 0 as *mut crate::stdlib::timezone);
    crate::stdlib::strftime(
        buf.as_mut_ptr(),
        ::std::mem::size_of::<[libc::c_char; 100]>() as libc::c_ulong,
        b"[%T.\x00" as *const u8 as *const libc::c_char,
        crate::stdlib::localtime(&mut tv.tv_sec),
    );
    crate::stdlib::sprintf(
        buf.as_mut_ptr()
            .offset(crate::stdlib::strlen(buf.as_mut_ptr()) as isize),
        b"%06ld]\x00" as *const u8 as *const libc::c_char,
        tv.tv_usec,
    );
    return buf.as_mut_ptr();
}
#[no_mangle]

pub unsafe extern "C" fn logprint(mut fmt: *const libc::c_char, mut args: ...) {
    let mut args_0: ::std::ffi::VaListImpl;
    args_0 = args.clone();
    crate::stdlib::vfprintf(crate::stdlib::stderr, fmt, args_0.as_va_list());
    crate::stdlib::fflush(crate::stdlib::stderr);
}
// cmdline parsing
#[no_mangle]

pub unsafe extern "C" fn next_param(
    mut src: *mut libc::c_char,
    mut c: libc::c_char,
) -> *mut libc::c_char {
    static mut str: *mut libc::c_char = 0 as *const libc::c_char as *mut libc::c_char;
    let mut ptr = 0 as *mut libc::c_char;
    let mut ret = 0 as *mut libc::c_char;
    if !src.is_null() {
        str = src
    }
    if !str.is_null() && {
        ptr = crate::stdlib::strchr(str, c as libc::c_int);
        !ptr.is_null()
    } {
        ret = str;
        *ptr = '\u{0}' as i32 as libc::c_char;
        str = ptr.offset(1 as libc::c_int as isize)
    } else {
        ret = str;
        str = 0 as *mut libc::c_char
    }
    return if !ret.is_null() && *ret.offset(0 as libc::c_int as isize) as libc::c_int != 0 {
        ret
    } else {
        0 as *mut libc::c_char
    };
}
// clock
#[no_mangle]

pub unsafe extern "C" fn gettime_ms() -> crate::squeezelite_h::u32_t {
    let mut ts = crate::stdlib::timespec {
        tv_sec: 0,
        tv_nsec: 0,
    };
    if crate::stdlib::clock_gettime(1 as libc::c_int, &mut ts) == 0 {
        return (ts.tv_sec * 1000 as libc::c_int as libc::c_long
            + ts.tv_nsec / 1000000 as libc::c_int as libc::c_long)
            as crate::squeezelite_h::u32_t;
    }
    let mut tv = crate::stdlib::timeval {
        tv_sec: 0,
        tv_usec: 0,
    };
    crate::stdlib::gettimeofday(&mut tv, 0 as *mut crate::stdlib::timezone);
    return (tv.tv_sec * 1000 as libc::c_int as libc::c_long
        + tv.tv_usec / 1000 as libc::c_int as libc::c_long)
        as crate::squeezelite_h::u32_t;
}
// mac address
// search first 4 interfaces returned by IFCONF
#[no_mangle]

pub unsafe extern "C" fn get_mac(mut mac: *mut crate::squeezelite_h::u8_t) {
    let mut utmac = 0 as *mut libc::c_char;
    let mut ifc = crate::stdlib::ifconf {
        ifc_len: 0,
        ifc_ifcu: crate::stdlib::C2RustUnnamed_22 {
            ifcu_buf: 0 as *mut libc::c_char,
        },
    };
    let mut ifr = 0 as *mut crate::stdlib::ifreq;
    let mut ifend = 0 as *mut crate::stdlib::ifreq;
    let mut ifreq = crate::stdlib::ifreq {
        ifr_ifrn: crate::stdlib::C2RustUnnamed_21 { ifrn_name: [0; 16] },
        ifr_ifru: crate::stdlib::C2RustUnnamed_20 {
            ifru_addr: crate::stdlib::sockaddr {
                sa_family: 0,
                sa_data: [0; 14],
            },
        },
    };
    let mut ifs: [crate::stdlib::ifreq; 4] = [crate::stdlib::ifreq {
        ifr_ifrn: crate::stdlib::C2RustUnnamed_21 { ifrn_name: [0; 16] },
        ifr_ifru: crate::stdlib::C2RustUnnamed_20 {
            ifru_addr: crate::stdlib::sockaddr {
                sa_family: 0,
                sa_data: [0; 14],
            },
        },
    }; 4];
    utmac = crate::stdlib::getenv(b"UTMAC\x00" as *const u8 as *const libc::c_char);
    if !utmac.is_null() {
        if crate::stdlib::strlen(utmac) == 17 as libc::c_int as libc::c_ulong {
            if crate::stdlib::sscanf(
                utmac,
                b"%2hhx:%2hhx:%2hhx:%2hhx:%2hhx:%2hhx\x00" as *const u8 as *const libc::c_char,
                &mut *mac.offset(0 as libc::c_int as isize) as *mut crate::squeezelite_h::u8_t,
                &mut *mac.offset(1 as libc::c_int as isize) as *mut crate::squeezelite_h::u8_t,
                &mut *mac.offset(2 as libc::c_int as isize) as *mut crate::squeezelite_h::u8_t,
                &mut *mac.offset(3 as libc::c_int as isize) as *mut crate::squeezelite_h::u8_t,
                &mut *mac.offset(4 as libc::c_int as isize) as *mut crate::squeezelite_h::u8_t,
                &mut *mac.offset(5 as libc::c_int as isize) as *mut crate::squeezelite_h::u8_t,
            ) == 6 as libc::c_int
            {
                return;
            }
        }
    }
    let ref mut fresh0 = *mac.offset(5 as libc::c_int as isize);
    *fresh0 = 0 as libc::c_int as crate::squeezelite_h::u8_t;
    let ref mut fresh1 = *mac.offset(4 as libc::c_int as isize);
    *fresh1 = *fresh0;
    let ref mut fresh2 = *mac.offset(3 as libc::c_int as isize);
    *fresh2 = *fresh1;
    let ref mut fresh3 = *mac.offset(2 as libc::c_int as isize);
    *fresh3 = *fresh2;
    let ref mut fresh4 = *mac.offset(1 as libc::c_int as isize);
    *fresh4 = *fresh3;
    *mac.offset(0 as libc::c_int as isize) = *fresh4;
    let mut s = crate::stdlib::socket(
        2 as libc::c_int,
        crate::stdlib::SOCK_DGRAM as libc::c_int,
        0 as libc::c_int,
    );
    ifc.ifc_len =
        ::std::mem::size_of::<[crate::stdlib::ifreq; 4]>() as libc::c_ulong as libc::c_int;
    ifc.ifc_ifcu.ifcu_req = ifs.as_mut_ptr();
    if crate::stdlib::ioctl(
        s,
        0x8912 as libc::c_int as libc::c_ulong,
        &mut ifc as *mut crate::stdlib::ifconf,
    ) == 0 as libc::c_int
    {
        ifend = ifs.as_mut_ptr().offset(
            (ifc.ifc_len as libc::c_ulong)
                .wrapping_div(::std::mem::size_of::<crate::stdlib::ifreq>() as libc::c_ulong)
                as isize,
        );
        ifr = ifc.ifc_ifcu.ifcu_req;
        while ifr < ifend {
            if (*ifr).ifr_ifru.ifru_addr.sa_family as libc::c_int == 2 as libc::c_int {
                crate::stdlib::strncpy(
                    ifreq.ifr_ifrn.ifrn_name.as_mut_ptr(),
                    (*ifr).ifr_ifrn.ifrn_name.as_mut_ptr(),
                    (::std::mem::size_of::<[libc::c_char; 16]>() as libc::c_ulong)
                        .wrapping_sub(1 as libc::c_int as libc::c_ulong),
                );
                if crate::stdlib::ioctl(
                    s,
                    0x8927 as libc::c_int as libc::c_ulong,
                    &mut ifreq as *mut crate::stdlib::ifreq,
                ) == 0 as libc::c_int
                {
                    crate::stdlib::memcpy(
                        mac as *mut libc::c_void,
                        ifreq.ifr_ifru.ifru_hwaddr.sa_data.as_mut_ptr() as *const libc::c_void,
                        6 as libc::c_int as libc::c_ulong,
                    );
                    if *mac.offset(0 as libc::c_int as isize) as libc::c_int
                        + *mac.offset(1 as libc::c_int as isize) as libc::c_int
                        + *mac.offset(2 as libc::c_int as isize) as libc::c_int
                        != 0 as libc::c_int
                    {
                        break;
                    }
                }
            }
            ifr = ifr.offset(1)
        }
    }
    crate::stdlib::close(s);
}
#[no_mangle]

pub unsafe extern "C" fn set_nonblock(mut s: crate::squeezelite_h::sockfd) {
    let mut flags = crate::stdlib::fcntl(s, 3 as libc::c_int, 0 as libc::c_int);
    crate::stdlib::fcntl(s, 4 as libc::c_int, flags | 0o4000 as libc::c_int);
}
// connect for socket already set to non blocking with timeout in seconds
#[no_mangle]

pub unsafe extern "C" fn connect_timeout(
    mut sock: crate::squeezelite_h::sockfd,
    mut addr: *const crate::stdlib::sockaddr,
    mut addrlen: crate::stdlib::socklen_t,
    mut timeout: libc::c_int,
) -> libc::c_int {
    let mut w = crate::stdlib::fd_set {
        __fds_bits: [0; 16],
    };
    let mut e = crate::stdlib::fd_set {
        __fds_bits: [0; 16],
    };
    let mut tval = crate::stdlib::timeval {
        tv_sec: 0,
        tv_usec: 0,
    };
    if crate::stdlib::connect(sock, addr, addrlen) < 0 as libc::c_int {
        if *crate::stdlib::__errno_location() != 115 as libc::c_int {
            return -(1 as libc::c_int);
        }
    }
    let mut __d0: libc::c_int = 0;
    let mut __d1: libc::c_int = 0;
    let fresh5 = &mut __d0;
    let fresh6;
    let fresh7 = &mut __d1;
    let fresh8;
    let fresh9 = (::std::mem::size_of::<crate::stdlib::fd_set>() as libc::c_ulong)
        .wrapping_div(::std::mem::size_of::<crate::stdlib::__fd_mask>() as libc::c_ulong);
    let fresh10 = &mut *w.__fds_bits.as_mut_ptr().offset(0 as libc::c_int as isize)
        as *mut crate::stdlib::__fd_mask;
    asm!("cld; rep; stosq" : "={cx}" (fresh6), "={di}" (fresh8) : "{ax}"
     (0 as libc::c_int), "0"
     (c2rust_asm_casts::AsmCast::cast_in(fresh5, fresh9)), "1"
     (c2rust_asm_casts::AsmCast::cast_in(fresh7, fresh10)) : "memory" :
     "volatile");
    c2rust_asm_casts::AsmCast::cast_out(fresh5, fresh9, fresh6);
    c2rust_asm_casts::AsmCast::cast_out(fresh7, fresh10, fresh8);
    w.__fds_bits[(sock
        / (8 as libc::c_int
            * ::std::mem::size_of::<crate::stdlib::__fd_mask>() as libc::c_ulong as libc::c_int))
        as usize] |= ((1 as libc::c_ulong)
        << sock
            % (8 as libc::c_int
                * ::std::mem::size_of::<crate::stdlib::__fd_mask>() as libc::c_ulong
                    as libc::c_int)) as crate::stdlib::__fd_mask;
    e = w;
    tval.tv_sec = timeout as crate::stdlib::__time_t;
    tval.tv_usec = 0 as libc::c_int as crate::stdlib::__suseconds_t;
    // only return 0 if w set and sock error is zero, otherwise return error code
    if crate::stdlib::select(
        sock + 1 as libc::c_int,
        0 as *mut crate::stdlib::fd_set,
        &mut w,
        &mut e,
        (if timeout != 0 {
            &mut tval
        } else {
            0 as *mut crate::stdlib::timeval
        }),
    ) == 1 as libc::c_int
        && w.__fds_bits[(sock
            / (8 as libc::c_int
                * ::std::mem::size_of::<crate::stdlib::__fd_mask>() as libc::c_ulong
                    as libc::c_int)) as usize]
            & ((1 as libc::c_ulong)
                << sock
                    % (8 as libc::c_int
                        * ::std::mem::size_of::<crate::stdlib::__fd_mask>() as libc::c_ulong
                            as libc::c_int)) as crate::stdlib::__fd_mask
            != 0 as libc::c_int as libc::c_long
    {
        let mut error = 0 as libc::c_int;
        let mut len =
            ::std::mem::size_of::<libc::c_int>() as libc::c_ulong as crate::stdlib::socklen_t;
        crate::stdlib::getsockopt(
            sock,
            1 as libc::c_int,
            4 as libc::c_int,
            &mut error as *mut libc::c_int as *mut libc::c_void,
            &mut len,
        );
        return error;
    }
    return -(1 as libc::c_int);
}
#[no_mangle]

pub unsafe extern "C" fn server_addr(
    mut server: *mut libc::c_char,
    mut ip_ptr: *mut crate::stdlib::in_addr_t,
    mut port_ptr: *mut libc::c_uint,
) {
    let mut res = 0 as *mut crate::stdlib::addrinfo;
    let mut hints = crate::stdlib::addrinfo {
        ai_flags: 0,
        ai_family: 0,
        ai_socktype: 0,
        ai_protocol: 0,
        ai_addrlen: 0,
        ai_addr: 0 as *mut crate::stdlib::sockaddr,
        ai_canonname: 0 as *mut libc::c_char,
        ai_next: 0 as *mut crate::stdlib::addrinfo,
    };
    let mut port = 0 as *const libc::c_char;
    if !crate::stdlib::strtok(server, b":\x00" as *const u8 as *const libc::c_char).is_null() {
        port = crate::stdlib::strtok(
            0 as *mut libc::c_char,
            b":\x00" as *const u8 as *const libc::c_char,
        );
        if !port.is_null() {
            *port_ptr = crate::stdlib::atoi(port) as libc::c_uint
        }
    }
    crate::stdlib::memset(
        &mut hints as *mut crate::stdlib::addrinfo as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::stdlib::addrinfo>() as libc::c_ulong,
    );
    hints.ai_family = 2 as libc::c_int;
    crate::stdlib::getaddrinfo(server, 0 as *const libc::c_char, &mut hints, &mut res);
    if !res.is_null() && !(*res).ai_addr.is_null() {
        *ip_ptr = (*((*res).ai_addr as *mut crate::stdlib::sockaddr_in))
            .sin_addr
            .s_addr
    }
    if !res.is_null() {
        crate::stdlib::freeaddrinfo(res);
    };
}
#[no_mangle]

pub unsafe extern "C" fn set_readwake_handles(
    mut handles: *mut crate::stdlib::pollfd,
    mut s: crate::squeezelite_h::sockfd,
    mut e: libc::c_int,
) {
    (*handles.offset(0 as libc::c_int as isize)).fd = s;
    (*handles.offset(1 as libc::c_int as isize)).fd = e;
    (*handles.offset(0 as libc::c_int as isize)).events = 0x1 as libc::c_int as libc::c_short;
    (*handles.offset(1 as libc::c_int as isize)).events = 0x1 as libc::c_int as libc::c_short;
}
#[no_mangle]

pub unsafe extern "C" fn wait_readwake(
    mut handles: *mut crate::stdlib::pollfd,
    mut timeout: libc::c_int,
) -> crate::squeezelite_h::event_type {
    if crate::stdlib::poll(handles, 2 as libc::c_int as crate::stdlib::nfds_t, timeout)
        > 0 as libc::c_int
    {
        if (*handles.offset(0 as libc::c_int as isize)).revents != 0 {
            return crate::squeezelite_h::EVENT_READ;
        }
        if (*handles.offset(1 as libc::c_int as isize)).revents != 0 {
            let mut val: crate::stdlib::eventfd_t = 0;
            crate::stdlib::eventfd_read((*handles.offset(1 as libc::c_int as isize)).fd, &mut val);
            return crate::squeezelite_h::EVENT_WAKE;
        }
    }
    return crate::squeezelite_h::EVENT_TIMEOUT;
}
// pack/unpack to network byte order
#[no_mangle]

pub unsafe extern "C" fn packN(
    mut dest: *mut crate::squeezelite_h::u32_t,
    mut val: crate::squeezelite_h::u32_t,
) {
    let mut ptr = dest as *mut crate::squeezelite_h::u8_t;
    *ptr = (val >> 24 as libc::c_int & 0xff as libc::c_int as libc::c_uint)
        as crate::squeezelite_h::u8_t;
    *ptr.offset(1 as libc::c_int as isize) = (val >> 16 as libc::c_int
        & 0xff as libc::c_int as libc::c_uint)
        as crate::squeezelite_h::u8_t;
    *ptr.offset(2 as libc::c_int as isize) = (val >> 8 as libc::c_int
        & 0xff as libc::c_int as libc::c_uint)
        as crate::squeezelite_h::u8_t;
    *ptr.offset(3 as libc::c_int as isize) =
        (val & 0xff as libc::c_int as libc::c_uint) as crate::squeezelite_h::u8_t;
}
#[no_mangle]

pub unsafe extern "C" fn packn(
    mut dest: *mut crate::squeezelite_h::u16_t,
    mut val: crate::squeezelite_h::u16_t,
) {
    let mut ptr = dest as *mut crate::squeezelite_h::u8_t;
    *ptr = (val as libc::c_int >> 8 as libc::c_int & 0xff as libc::c_int)
        as crate::squeezelite_h::u8_t;
    *ptr.offset(1 as libc::c_int as isize) =
        (val as libc::c_int & 0xff as libc::c_int) as crate::squeezelite_h::u8_t;
}
#[no_mangle]

pub unsafe extern "C" fn unpackN(
    mut src: *mut crate::squeezelite_h::u32_t,
) -> crate::squeezelite_h::u32_t {
    let mut ptr = src as *mut crate::squeezelite_h::u8_t;
    return ((*ptr as libc::c_int) << 24 as libc::c_int
        | (*ptr.offset(1 as libc::c_int as isize) as libc::c_int) << 16 as libc::c_int
        | (*ptr.offset(2 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int
        | *ptr.offset(3 as libc::c_int as isize) as libc::c_int)
        as crate::squeezelite_h::u32_t;
}
#[no_mangle]

pub unsafe extern "C" fn unpackn(
    mut src: *mut crate::squeezelite_h::u16_t,
) -> crate::squeezelite_h::u16_t {
    let mut ptr = src as *mut crate::squeezelite_h::u8_t;
    return ((*ptr as libc::c_int) << 8 as libc::c_int
        | *ptr.offset(1 as libc::c_int as isize) as libc::c_int)
        as crate::squeezelite_h::u16_t;
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
#[no_mangle]

pub unsafe extern "C" fn touch_memory(
    mut buf: *mut crate::squeezelite_h::u8_t,
    mut size: crate::stddef_h::size_t,
) {
    let mut ptr = 0 as *mut crate::squeezelite_h::u8_t;
    ptr = buf;
    while ptr < buf.offset(size as isize) {
        *ptr = 0 as libc::c_int as crate::squeezelite_h::u8_t;
        ptr =
            ptr.offset(crate::stdlib::sysconf(crate::stdlib::_SC_PAGESIZE as libc::c_int) as isize)
    }
}
